/**
 * Created by zjw-pc on 2016/5/21.
 * 合同列表
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myContractController", myContractController);

  function myContractController($state,$ionicPopup,$location, $cordovaToast, $stateParams, loadingService, myContractService, accountService) {
    var myContract = this;
    myContract.fnContractListGet = fnContractListGet;//定义方法
    myContract.myContractList = [];//创建新的数组用来接收数据并展示
    myContract.fnGoList = fnGoList;//定义方法
    myContract.customerID = accountService.fnGetUser().CustomerID;//获取customerID
    function fnGoList() {
      $state.go('tab.person');
      //$location.path("tab/person");
    }

    /**
     * 请求我的合同列表
     */
    function fnContractListGet() {
      loadingService.show();
      myContractService.FunContractListGet(myContract.customerID)
        .then(function (data) {
          if (data[0].length <= 0) {
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '暂无合同！'
            });
            alertPopup.then(function (res) {
              $location.path("/tab/person");
            });
            loadingService.hide();
            return;
          }
          for (var i = 0; i < data[0].length; i++) {
            var item = {
              "ContractID": data[0][i].ContractID,
              "CourseID": data[0][i].CourseID,
              "CourseName": data[0][i].CourseName,
              "CustomerID": data[0][i].CustomerID,
              "isClosed": data[0][i].isClosed,
              "isFreezed": data[0][i].isFreezed,
              "Termination": data[0][i].Termination
            }
            myContract.myContractList.push(item);
          }
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //启动方法
    fnContractListGet()

  }
})();
