/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myContractTermsController", myContractTermsController);

  function myContractTermsController($ionicPopup, $location, $stateParams, $cordovaToast, loadingService, myContractService) {
    var contractTerms = this;
    contractTerms.fnContractContentGet = fnContractContentGet;//定义方法
    contractTerms.ContractContentLists = new Array();//创建新的数组用来接收数据并展示
    contractTerms.ContractContentID = $stateParams.ContractContentID;//获取ContractContentID这里替换为ContractID，简便所以未修改
    /**
     * 请求我的合同条款列表
     */
    function fnContractContentGet() {
      loadingService.show();
      myContractService.FunContractContentGet(contractTerms.ContractContentID)
        .then(function (data) {

          contractTerms.ContractContentLists = data;


          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //启动方法
    fnContractContentGet()
  }
})()
