/**
 * Created by trueideal on 2016/5/13.
 */
(function () {
    'use strict';
    angular.module("myApp")
        .controller("userLoginController", userLoginController);

    function userLoginController($ionicPopup, $location, $cordovaToast, loadingService, accountService, _customerType) {
        var userLogin = this;
        userLogin.fnLogin = fnLogin;
        userLogin.customerType = false;
        userLogin.fnGoBack = fnGoBack;
        function fnGoBack() {
            $location.path("tab/home")
        }

        function fnLogin() {
            loadingService.show();
            var name = userLogin.name;
            _customerType = userLogin.customerType ? 1 : 0;
            //定义customerType值 2016/8/4
            var data = {
                "customerType": _customerType
            };
            accountService.fnSetCustomerType(data);//存入CustomerType值 2016/8/4
            accountService.fnUserLogin(userLogin.name, userLogin.password, 0)
                .then(function (data) {
                    if (data.CustomerID == undefined) {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('登录信息不正确！');
                        return;
                    }
                    //console.log(data.CustomerID)
                    loadingService.hide();
                    $location.path("tab/person")
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }
    }
})()
