/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("myCourseController", myCourseController);

    function myCourseController($state, $scope, $location, $cordovaToast, loadingService, myCourseService, accountService) {
        var myCourse = this;
        myCourse.fnCourseListGet = fnCourseListGet;//定义方法
        myCourse.fnGoList = fnGoList;
        myCourse.CourseList = [];//创建新的数组用来接收数据并展示
        myCourse.customerID = accountService.fnGetUser().CustomerID;//获取customerID
        /**
         * 下拉刷新 2017/9/19
         * @type {loadNewerStories}
         */
        myCourse.loadNewerStories = loadNewerStories;
        function loadNewerStories() {
            myCourse.CourseList = [];
            fnCourseListGet();
            $scope.$broadcast('scroll.refreshComplete');//广播结束
        }

        function fnGoList() {
            $state.go('tab.person');
            //$location.path("tab/person");
        }

        myCourse.isShowImgNull = false;
        /**
         * 请求我的章节中的课程列表
         */
        function fnCourseListGet() {
            loadingService.show();
            myCourseService.FunCourseListGet(myCourse.customerID)
                .then(function (data) {
                    if (data[0].length <= 0) {
                        myCourse.isShowImgNull = true;
                        //var alertPopup = $ionicPopup.alert({
                        //  title: '提示',
                        //  template: '暂无内容！'
                        //});
                        //alertPopup.then(function (res) {
                        //  $location.path("/tab/person");
                        //});
                        loadingService.hide();
                        return;
                    }
                    for (var i = 0; i < data[0].length; i++) {
                        var item = {
                            "ContractID": data[0][i].ContractID,
                            "CourseID": data[0][i].CourseID,
                            "CourseName": data[0][i].CourseName,
                            "CustomerID": data[0][i].CustomerID,
                            "isClosed": data[0][i].isClosed,
                            "isFreezed": data[0][i].isFreezed,
                            "Termination": data[0][i].Termination,
                        }
                        myCourse.CourseList.push(item);
                    }
                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        //启动方法
        fnCourseListGet()

    }
})()
