/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myCourseListController", myCourseListController);

  function myCourseListController($state,accountService, learingingBoardService, $ionicPopup, $location, $stateParams, $cordovaToast, loadingService, myCourseService) {
    var myCourseList = this;
    var ary = [];
    myCourseList.fnChapterListGet = fnChapterListGet;//定义章节方法
    myCourseList.fnGoList = fnGoList;//定义返回方法
    myCourseList.CourseLists = [];//创建新的数组用来接收数据并展示
    myCourseList.chapterLists = [];//创建新的数组用来接收数据并展示
    myCourseList.ContractID = $stateParams.ContractID;//获取ContractID
    myCourseList.CourseName = $stateParams.CourseName;//获取CourseName
    myCourseList.customerID = accountService.fnGetUser().CustomerID;//获取customerID
    myCourseList.init = init;
    function fnGoList() {
        $state.go('course');
    }

    myCourseList.fnContinueLearningQuestionId = fnContinueLearningQuestionId;//2017/5/24
    function fnContinueLearningQuestionId(ChapterID, index, courseItem) {
      learingingBoardService.FnContinueLearningQuestionId(ChapterID, index, courseItem)
        .then(function (data) {
            var myPopup = $ionicPopup.show({
              title: '用户提示',
              buttons: [
                {
                  text: '继续学习',
                  onTap: function (e) {
                    $location.path("my/testBoard/" + "" + "/" + "" +
                      "/''/" + data + "/" + myCourseList.CourseName + "/" + courseItem.ChapterID + "/" + 1 + "/" +
                      courseItem.ContractID + "/" + courseItem.CourseID + "/" + courseItem.ExamPaperID + "/chapter/normal");
                  }
                },
                {
                  text: '<b>重新学习</b>',
                  type: 'button-positive',
                  onTap: function (e) {
                    $location.path("my/testBoard/" + "" + "/" + "" + "/''/sssssss/" + myCourseList.CourseName + "/"
                      + courseItem.ChapterID + "/" + 1 + "/" + courseItem.ContractID + "/" + courseItem.CourseID +
                      "/" + courseItem.ExamPaperID + "/chapter/normal");
                  }
                },
              ]
            });
          },
          function (error) {
            $cordovaToast.showShortBottom('网络出现异常！');
          }
        );
    }


    /**
     * 请求我的章节中的章节列表
     */
    function fnChapterListGet() {
      loadingService.show();
      myCourseService.FunChapterListGet(myCourseList.ContractID, myCourseList.customerID)
        .then(function (data) {
            myCourseList.isCFA = false;
            //myCourseList.isBig = false;
            if (data[1] == undefined) {
              //myCourseList.isBig = true;
              var item = {
                "null": ""
              }
              data.push(item);
            }
            if (data[1].length > 0) {
              myCourseList.isCFA = true;
            }

            for (var i = 0; i < data[0].length; i++) {
              var item = {
                "ChapterID": data[0][i].ChapterID,
                "ChapterName": data[0][i].ChapterName,
                "ContractID": data[0][i].ContractID,
                "CourseID": data[0][i].CourseID,
                "isClosed": data[0][i].isClosed,
                "isFreezed": data[0][i].isFreezed,
                "Termination": data[0][i].Termination,
                "ChapterTpicSum": Math.ceil(parseFloat(data[0][i].ChapterTpicSum) / 70),
                "Arrays": init(Math.ceil(parseFloat(data[0][i].ChapterTpicSum) / 70), myCourseList.isCFA),
                "TpicEnd": [],//cfa题数
                "SegmentID": []//cfa SegmentID
              }

              myCourseList.CourseLists.push(item);
            }
            //判断是否为cfa样式
            if (data[1].length > 0) {
              var ints = 1;
              for (var i = 0; i < data[1].length; i++) {
                for (var j = 0; j < myCourseList.CourseLists.length; j++) {
                  if (myCourseList.CourseLists[j].ChapterID == data[1][i].ChapterID) {
                    myCourseList.CourseLists[j].Arrays.push(initCFA(data[1][i], myCourseList.CourseLists[j].Arrays, ints++))
                    myCourseList.CourseLists[j].TpicEnd.push(data[1][i].QuestionCount)
                    myCourseList.CourseLists[j].SegmentID.push(data[1][i].SegmentID)
                  }
                }
              }
            }

            loadingService.hide();
          }
          ,
          function (error) {
            $cordovaToast.showShortBottom('网络出现异常！');
          }
        );
    }

    //启动方法
    fnChapterListGet();
    /**
     * 取出长度进行初始化数组
     * @param arr
     * @returns {Array}
     */
    function init(arr, iscfa) {
      var arry = [];
      for (var i = 0; i < arr; i++) {
        arry.push(i + 1);
      }
      if (iscfa) {
        return [];
      } else {
        return arry;
      }
    }

    //cfa的小结获取
    function initCFA(arr, arr2, ints) {
      if (ints == 1) {
        arr2.length = 0;
      }

      return arr.SegmentName;
    }

    //cfa的小结题数获取
    function initContent(arr) {
      return arr.QuestionCount;
    }

    //cfa的SegmentID获取
    function initSegmentID(arr) {
      return arr.SegmentID;
    }


  }
})()
