/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("mySpotQuestionsController", mySpotQuestionsController);

    function mySpotQuestionsController($scope, learingingBoardService, $state, $ionicPopup, $location, $cordovaToast, loadingService, mySpotQuestionsService, accountService) {
        var mySpotQuestions = this;
        mySpotQuestions.fnExamListGet = fnExamListGet;//定义方法
        mySpotQuestions.fnGoList = fnGoList;//定义方法
        mySpotQuestions.fnBoolean_CourseInList = fnBoolean_CourseInList;//定义方法
        mySpotQuestions.fnLoadExamByCourseID = fnLoadExamByCourseID;//定义方法
        mySpotQuestions.aryExams = [];//创建新的数组用来接收数据并展示
        mySpotQuestions.aryCourselst = [];
        //mySpotQuestions.ary = [];
        mySpotQuestions.customerID = accountService.fnGetUser().CustomerID;//获取customerID
        function fnGoList() {
            $state.go('tab.person');
            //$location.path("tab/person");
        }

        /**
         * 下拉刷新 2017/9/19
         * @type {loadNewerStories}
         */
        mySpotQuestions.loadNewerStories = loadNewerStories;
        function loadNewerStories() {
            mySpotQuestions.aryExams = [];
            mySpotQuestions.aryCourselst = [];
            fnExamListGet();
            $scope.$broadcast('scroll.refreshComplete');//广播结束
        }

        mySpotQuestions.fnGetExanmUnfinished = fnGetExanmUnfinished;//2017/5/31
        function fnGetExanmUnfinished(ExamPaperID, Item, ExamItem) {
            learingingBoardService.FnGetExanmUnfinished(ExamPaperID)
                .then(function (data) {
                        if (data == "") {// 判断做题之前未交卷和零分的 2017/6/1
                            $location.path("my/testBoard/''/''/''/" + "" + "/''/''/''/" + ExamItem.ContractID +
                                "/" + Item.CourseID + "/" + Item.ExamPaperID + "/exam/normal");
                        } else {
                            var myPopup = $ionicPopup.show({
                                title: '用户提示',
                                template: '未交卷和0分可以继续做题',
                                buttons: [
                                    {
                                        text: '继续学习',
                                        onTap: function (e) {
                                            $location.path("my/testBoard/''/''/''/" + data + "/''/''/''/" + ExamItem.ContractID +
                                                "/" + Item.CourseID + "/" + Item.ExamPaperID + "/exam/normal");
                                        }
                                    },
                                    {
                                        text: '<b>重新学习</b>',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            $location.path("my/testBoard/''/''/''/" + "" + "/''/''/''/" + ExamItem.ContractID +
                                                "/" + Item.CourseID + "/" + Item.ExamPaperID + "/exam/normal");
                                        }
                                    },
                                ]
                            });
                        }
                    },
                    function (error) {
                        $cordovaToast.showShortBottom('网络出现异常！');
                    }
                );
        }

        mySpotQuestions.isShowImgNull = false;
        /**
         * 请求我的押题课程列表
         */
        function fnExamListGet() {
            loadingService.show();
            mySpotQuestionsService.FunExamListGet(mySpotQuestions.customerID)
                .then(function (data) {
                        if (data[0].length <= 0) {
                            mySpotQuestions.isShowImgNull = true;
                            loadingService.hide();
                            return;
                        }
                        var datalst = data[0];

                        for (var i = 0; i < datalst.length; i++) {
                            if (!fnBoolean_CourseInList(datalst[i].CourseID, mySpotQuestions.aryCourselst)) {
                                var item = {
                                    "CourseID": datalst[i].CourseID,
                                    "ExaminationTimeID": datalst[i].ExaminationTimeID,
                                    "ExamPaperID": "",
                                    "CourseName": datalst[i].CourseName,
                                    "ContractID": datalst[i].ContractID,
                                    "StartDate": datalst[i].StartDate,
                                    "Time": datalst[i].Time,
                                    "CloseDate": datalst[i].CloseDate,
                                    "ExamTime": "",
                                    "ShowDate": ""
                                };
                                mySpotQuestions.aryCourselst.push(item);
                            }
                        }
                        for (var i = 0; i < mySpotQuestions.aryCourselst.length; i++) {
                            var Examlst = fnLoadExamByCourseID(mySpotQuestions.aryCourselst[i].CourseID, mySpotQuestions.aryCourselst);
                            mySpotQuestions.aryExams.push(Examlst);
                        }
                        var date = new Date();
                        for (var i = 0; i < mySpotQuestions.aryExams.length; i++) {
                            if (accountService.fnGetCustomerType().customerType == 0) {//2017/10/16  大客户押题
                                if (mySpotQuestions.aryExams[i][0].ExaminationTimeID == "") {
                                    mySpotQuestions.aryExams[i][0].ExamTime = "设置期数";
                                }

                                else {
                                    if (Date.parse(new Date(mySpotQuestions.aryExams[i][0].StartDate)) != "" && Date.parse(new Date(mySpotQuestions.aryExams[i][0].StartDate)) != undefined && Date.parse(new Date(mySpotQuestions.aryExams[i][0].StartDate)) != null) {
                                        console.log(i + "-->" + parseInt(Date.parse(new Date(mySpotQuestions.aryExams[i][0].StartDate))) + "****" + "--->" + Date.parse(date))
                                        //如果是结束时间小于当天，考试结束 2017/11/13
                                        if (parseInt(Date.parse(new Date(mySpotQuestions.aryExams[i][0].CloseDate))) < Date.parse(date)) {
                                            mySpotQuestions.aryExams[i][0].ExamTime = "本期考试已结束！" + mySpotQuestions.aryExams[i][0].CloseDate + Date.parse(date);//+"/*-/"+parseInt(Date.parse(new Date(mySpotQuestions.aryExams[i][0].StartDate)))
                                        } else {
                                            mySpotQuestions.aryExams[i][0].ExamTime = ("您报考的科目押题未上线，押题上线时间为考前15天！" + mySpotQuestions.aryExams[i][0].Time);// + "//" + parseInt((Date.parse(new Date("2017-6-21")) - Date.parse(date)) / (1000 * 60 * 60 * 24)) + "**" //mySpotQuestions.ar
                                        }

                                        mySpotQuestions.funExamPaperContent(mySpotQuestions.aryExams[i][0].CourseID,
                                            mySpotQuestions.aryExams[i][0].ExaminationTimeID
                                        );
                                    }
                                }

                            } else {
                                mySpotQuestions.funExamPaperContent(mySpotQuestions.aryExams[i][0].CourseID, "");
                            }


                        }

                        loadingService.hide();
                    },
                    function (error) {
                        $cordovaToast.showShortBottom('网络出现异常！');
                    }
                );
        }

        mySpotQuestions.funExamPaperContent = funExamPaperContent; //押题列表里的具体押题 2017/6/19
        function funExamPaperContent(CourseID, ExaminationTimeID) {
            mySpotQuestionsService.FunExamPaperContent(CourseID, ExaminationTimeID)
                .then(function (data) {
                    if (data[0].length > 0) {
                        for (var i = 0; i < mySpotQuestions.aryExams.length; i++) {
                            if (mySpotQuestions.aryExams[i][0].CourseID == data[0][0].CourseID) {
                                mySpotQuestions.aryExams[i][0].ExamIsShow = true;
                                mySpotQuestions.aryExams[i][0].ExamAry = data
                            }
                        }
                    }
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        mySpotQuestions.fnOnClick = fnOnClick;
        function fnOnClick(str, ContractID) {
            if (str == "设置期数") {
                $location.path("my/contractSetting" + "/" + ContractID);
            }
        }

        //启动方法
        fnExamListGet();
        /**
         * 查重
         * @param CourseID
         * @param aryCourseList
         * @returns {boolean}
         */
        function fnBoolean_CourseInList(CourseID, aryCourseList) {
            for (var i = 0; i < aryCourseList.length; i++) {
                if (aryCourseList[i].CourseID == CourseID) {
                    return true;
                }
            }
            return false;
        };

        function fnLoadExamByCourseID(CourseID, datalst) {
            var ExamList = [];
            var intIndex = 0;
            for (var i = 0; i < datalst.length; i++) {
                if (datalst[i].CourseID == CourseID) {
                    var item = {
                        "CourseID": datalst[i].CourseID,
                        "ContractID": datalst[i].ContractID,
                        "CourseName": datalst[i].CourseName,
                        "StartDate": datalst[i].StartDate,
                        "CloseDate": datalst[i].CloseDate,
                        "Time": datalst[i].Time,
                        "ExaminationTimeID": datalst[i].ExaminationTimeID,
                        "ExamIsShow": false,
                        "ExamPaperID": datalst[i].ExamPaperID,
                        "ExamTime": datalst[i].ExamTime,
                        "ExamName": "第" + (intIndex + 1) + "套",
                        "ExamAry": [],
                        "ShowDate": (datalst[i].ShowDate).replace(/(\d{4}).(\d{1,2}).(\d{1,2}).+/mg, '$1-$2-$3')// 2017/5/23
                    };
                    ExamList.push(item);
                    intIndex++;
                }
            }
            return ExamList;
        };
    }
})()
