/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("myVideoController", myVideoController);

    function myVideoController($ionicPopover, $scope, $cordovaFile, $cordovaNetwork, $ionicHistory, $timeout, $cordovaFileTransfer, $ionicLoading, $cordovaToast, $ionicPopup, $location, $stateParams, loadingService, myVideoService, $interval, accountService) {
        var myVideo = document.getElementById('myVideo');
        var myVideoList = this;
        var worker;

        myVideoList.fnPlayerListGet = fnPlayerListGet;//定义方法
        myVideoList.fnGoList = fnGoList;//定义返回方法
        myVideoList.fnVideoSaveSet = fnVideoSaveSet;//定义保存时间方法
        myVideoList.fnFirstLearning = fnFirstLearning;//定义第一次进入方法
        myVideoList.VideoLists = [];//创建新的数组用来接收数据并展示
        myVideoList.CourseID = $stateParams.CourseID;
        myVideoList.ContractID = $stateParams.ContractID;
        myVideoList.play = play;//定义点击选择方法
        myVideoList.fnVideoTime = fnVideoTime;//定义时间方法
        myVideoList.videoItemTime = 0;
        myVideoList.videoLerningID = "";
        myVideoList.items = 0;
        myVideoList.VideoID = "";
        myVideoList.CustomerID = accountService.fnGetUser().CustomerID;
        var objtimer = null;

        // 判断各种浏览器，找到正确的方法 2017/8/14
        function launchFullscreen(element) {
            if (element.requestFullscreen) {
                element.requestFullscreen();
            } else if (element.mozRequestFullScreen) {
                element.mozRequestFullScreen();
            } else if (element.webkitRequestFullscreen) {
                element.webkitRequestFullscreen();
            } else if (element.msRequestFullscreen) {
                element.msRequestFullscreen();
            }
        }

        /**
         * 自动播放下一个  2017/8/9
         * @type {number}
         */
            //myVideoList.curr = 0;
            //myVideo.addEventListener("ended", function () {
            //    //alert("已播放完成，继续下一个视频"); 2017/8/9
            //    try {
            //        if (myVideoList.curr >= myVideoList.SegmentDate.length) {
            //            $cordovaToast.showShortBottom('已全部播放完成');
            //            myVideo.pause();
            //            myVideoList.curr = myVideoList.SegmentDate.length;
            //        } else {
            //            $cordovaToast.showShortBottom('已播放完成，继续下一个视频！');
            //            myVideoList.play(myVideoList.SegmentDate[myVideoList.curr].VideoUrl, myVideoList.SegmentDate[myVideoList.curr].item,
            //                myVideoList.SegmentDate[myVideoList.curr].LearningID, myVideoList.SegmentDate[myVideoList.curr].VideoID,
            //                myVideoList.SegmentDate[myVideoList.curr].VFile);
            //        }
            //    }
            //    catch (e) {
            //    }
            //});


        myVideoList.isDownloadNextTrue = true;
        myVideoList.fnDownloadVideo = fnDownloadVideo;
        function fnDownloadVideo(url, segment, downloadIndex) {
            /**
             * 将方法转至线程
             * @param url
             * @param segment
             * @param downloadIndex
             */
            function downVideo(url, segment, downloadIndex) {
                $cordovaFile.checkFile(cordova.file.externalRootDirectory + "lekaoVideo/", segment).then(function (success) {
                    //alert(cordova.file.externalRootDirectory + "lekaoVideo/" + segment + "已经有下载文件")

                }, function (error) {
                    var targetPath = cordova.file.externalRootDirectory + "lekaoVideo/" + segment + ".dat";
                    var trustHosts = true;
                    var options = {};
                    //$cordovaToast.showShortBottom('开始下载!');
                    $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
                        .then(function (result) {
                            // Success!
                            //修改名字
                            $cordovaFile.moveFile(cordova.file.externalRootDirectory + "lekaoVideo/", segment + ".dat", cordova.file.externalRootDirectory + "lekaoVideo/", segment)
                            myVideoList.VideoLists[downloadIndex].downLoadShow = true;
                            //$cordovaToast.showShortBottom('下载成功！');
                        }, function (err) {
                            // Error
                            //$cordovaToast.showShortBottom('下载失败！');
                        }, function (progress) {
                            myVideoList.VideoLists[downloadIndex].ProgressItem = Math.floor((progress.loaded / progress.total) * 100) + "%";
                            if ((progress.loaded / progress.total) * 100 > 99) {
                                myVideoList.VideoLists[downloadIndex].downLoadShow = true;
                            }

                        });
                });

            }

            //启动doDown脚本
            worker = new Worker("js/controllers/course/doDown.js");

            worker.postMessage(downVideo(url, segment, downloadIndex));

            worker.onmessage = function () {
                //alert("data1------------>:" + event.data)
            };

        }

        /**
         * 返回
         */
        function fnGoList() {
            myVideo.pause();
            $interval.cancel(objtimer);
            $ionicHistory.goBack();
        }

        //// 2017/9/21 视频倍速修改
        //myVideoList.seleList = [1, 1.25, 1.5, 2, 3, 5];//选择数组 2017/9/21
        //myVideoList.isShowSet = false;//判断是否显示  播放设置 2017/9/21
        //myVideoList.selecteds = 1; //默认值 2017/9/21
        //myVideoList.popoverShow = popoverShow;//显示协议
        //myVideoList.popoverClose = popoverClose;//关闭协议
        //
        //$ionicPopover.fromTemplateUrl('select-pop.html', {
        //    scope: $scope
        //}).then(function (showProcotols) {
        //    myVideoList.selePop = showProcotols;
        //});
        //
        //function popoverShow($event) {
        //    myVideoList.selePop.show($event);
        //}
        //
        //function popoverClose($event) {
        //    myVideoList.selePop.hide();
        //}
        //
        //myVideoList.selectDatas = selectDatas;// 2017/9/21
        //function selectDatas(i) {
        //    document.getElementById('myVideo').playbackRate = i;
        //    myVideoList.selecteds = i;
        //    //alert("myVideo.playbackRate:"+myVideo.playbackRate)
        //    myVideoList.popoverClose();
        //}
        //
        //// 2017/9/21
        //var eventTester = function (e) {
        //    myVideo.addEventListener(e, function () {
        //        if (e == "play") {
        //            myVideoList.isShowSet = true;
        //        } else if (e == "ended") {
        //            myVideoList.isShowSet = false;
        //        }
        //        console.log((new Date()).getTime(), e)
        //    }, false);
        //}
        //eventTester("play");// 2017/9/21 监听播放状态
        //eventTester("ended");// 2017/9/21 监听结束状态
        //eventTester("ratechange");

        /**
         * 点击切换视频
         * @param url
         */
        function play(url, items, LearningID, VideoID, curVideo) {
            myVideoList.selecteds = 1; //重置默认值 2017/9/21

            //myVideoList.curr = items;//选择的视频等于自动播放的位置 2017/8/9
            myVideoList.imgbg = "img/video_loadings.gif";

            //try {
            //    // listen for Online event
            //    var type = $cordovaNetwork.getNetwork()
            //    if (type == Connection.WIFI) { //TODO something
            //        //如果为WiFi开始下载
            //        $cordovaFile.getFreeDiskSpace()//获取磁盘空间
            //            .then(function (success) {
            //                if ((success / 1024) > 500) {
            //                    myVideoList.fnDownloadVideo(url, curVideo, items);
            //                }
            //            }, function (error) {
            //            });
            //    }
            //    else if (type == Connection.CELL_4G || type == Connection.CELL_3G) {
            //        //TODO something
            //    }
            //} catch (e) {
            //}

            if (objtimer != null) {
                myVideoList.fnVideoSaveSet(LearningID, VideoID, myVideoList.ContractID, myVideoList.CustomerID);
                myVideoList.videoItemTime = 0;
                $interval.cancel(objtimer);
                objtimer = $interval(myVideoList.fnVideoTime, 1000);
                //$interval.cancel(objtimer);
            }
            myVideoList.items = items;
            myVideoList.VideoID = VideoID;
            for (var i = 0; i < myVideoList.SegmentDate.length; i++) {//改变选中的颜色 2017/8/9
                myVideoList.SegmentDate[i].color = isLooks(myVideoList.SegmentDate[i].ActualTime);
                myVideoList.SegmentDate[i].bg_color = "";
            }
            myVideoList.SegmentDate[items].videoTime = myVideoList.videoItemTime;
            myVideoList.SegmentDate[items].LearningID = myVideoList.videoLerningID;
            myVideoList.SegmentDate[items].color = "#3da4ba";
            myVideoList.SegmentDate[items].bg_color = "#c7f7ff"; // 2017/8/9
            myVideo.load();
            //视频的防止链接失效 2017/8/31
            myVideoService.GetVideoUrl(myVideoList.CourseID, myVideoList.ContractID, myVideoList.VideoID)
                .then(function (data) {
                    myVideo.src = data[0][0].VideoUrl;
                    //myVideoList.curr++;//播放开始改变下一个播放列表位置 2017/8/9
                    //myVideo.playbackRate=5;
                    myVideo.play();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });


            //launchFullscreen(myVideo); // 某个页面元素 2017/8/14

            //if (curVideo != null) {
            //    try {
            //        $cordovaFile.checkFile(cordova.file.externalRootDirectory + "lekaoVideo/", curVideo).then(function (success) {
            //            myVideoList.VideoLists[items].downLoadShow = true;
            //            url = cordova.file.externalRootDirectory + "lekaoVideo/" + curVideo;
            //            myVideo.src = url;
            //            myVideoList.curr++;//播放开始改变下一个播放列表位置 2017/8/9
            //            myVideo.play();
            //        }, function (error) {
            //            myVideo.src = url;
            //            myVideoList.curr++;//播放开始改变下一个播放列表位置 2017/8/9
            //            myVideo.play();
            //
            //        });
            //    } catch (e) {
            //        myVideo.src = url;
            //        myVideoList.curr++;//播放开始改变下一个播放列表位置 2017/8/9
            //        myVideo.play();
            //    }
            //}

        }

        /**
         * 请求我视频
         */
        function fnPlayerListGet() {
            loadingService.show();
            myVideoService.FunPlayerListGet(myVideoList.CourseID, myVideoList.ContractID)
                .then(function (data) {
                    if (data == "Video") { //未找到视频
                        var items = {
                            "Segment": "没有找到视频!",
                            "VideoUrl": ""
                        }
                        myVideoList.VideoLists.push(items);
                        loadingService.hide();
                        return;
                    }
                    myVideoList.courseName = data[1][0].CourseName;
                    myVideoList.KnowledgeDate = [];//小結數組
                    myVideoList.SegmentDate = [];//视频數組
                    //加载视频列表 2017/8/17
                    for (var i = 0; i < data[0].length; i++) {
                        if (!fnSelectList(data[0][i].VideoChapterName, myVideoList.VideoLists, "VideoChapterName")) {
                            var item = {//区分章节名称
                                "Segment": data[0][i].Segment,//第三层
                                "Knowledge": data[0][i].Knowledge,//第二层
                                "VideoChapterName": data[0][i].VideoChapterName,//第一层
                                "KnowledgeDate": []

                            }
                            myVideoList.VideoLists.push(item);
                        }

                        if (!fnSelectList(data[0][i].Knowledge, myVideoList.KnowledgeDate, "Knowledge")) {
                            var item = {//区分小结名称
                                "Segment": data[0][i].Segment,//第三层
                                "Knowledge": data[0][i].Knowledge,//第二层
                                "VideoChapterName": data[0][i].VideoChapterName,//第一层
                                "OrderNo": data[0][i].OrderNo,
                                "ChapterID": data[0][i].ChapterID,
                                "ChapterNum": data[0][i].ChapterNum,
                                "VideoUrl": data[0][i].VideoUrl,
                                "VideoID": data[0][i].VideoID,
                                "color": isLooks(data[0][i].ActualTime), // 2017/8/9
                                "bg_color": "",
                                "item": i,
                                "videoTime": 0,
                                "ActualTime": data[0][i].ActualTime,//看过时间  2017/8/9
                                "VideoTime": data[0][i].VideoTime,//视频总时间 2017/8/9
                                "LearningID": fnFirstLearning(data[0][i].LearningID),
                                "ProgressItem": 0,//为下载时间的长度赋值
                                "downLoadShow": false,
                                "VFile": data[0][i].VFile, //这里是视频的名字
                                "SegmentDate": []

                            };
                            myVideoList.KnowledgeDate.push(item);
                        }

                        var items = {//视频数组
                            "Segment": data[0][i].Segment,//第三层
                            "Knowledge": data[0][i].Knowledge,//第二层
                            "VideoChapterName": data[0][i].VideoChapterName,//第一层
                            "OrderNo": data[0][i].OrderNo,
                            "ChapterID": data[0][i].ChapterID,
                            "ChapterNum": data[0][i].ChapterNum,
                            "VideoUrl": data[0][i].VideoUrl,
                            "VideoID": data[0][i].VideoID,
                            "color": isLooks(data[0][i].ActualTime), // 2017/8/9
                            "bg_color": "",
                            "item": i,
                            "videoTime": 0,
                            "ActualTime": data[0][i].ActualTime,//看过时间  2017/8/9
                            "VideoTime": data[0][i].VideoTime,//视频总时间 2017/8/9
                            "LearningID": fnFirstLearning(data[0][i].LearningID),
                            "ProgressItem": 0,//为下载时间的长度赋值
                            "downLoadShow": false,
                            "SegmentDate": [],//2017/8/17
                            "VFile": data[0][i].VFile //这里是视频的名字
                        };
                        myVideoList.SegmentDate.push(items);
                    }

                    //for (var i = 0; i < myVideoList.VideoLists.length; i++) {
                    //    if (myVideoList.SegmentDate[0].Knowledge != null && myVideoList.SegmentDate[0].Knowledge != "") {
                    //        for (var j = 0; j < myVideoList.KnowledgeDate.length; j++) {//筛选章节下课程 加入课程
                    //            if (myVideoList.VideoLists[i].VideoChapterName == myVideoList.KnowledgeDate[j].VideoChapterName) {
                    //                myVideoList.VideoLists[i].KnowledgeDate.push(myVideoList.KnowledgeDate[j]);
                    //            }
                    //        }
                    //        for (var k = 0; k < myVideoList.SegmentDate.length; k++) {//筛选小结下的视频节点 加入视频数组
                    //            if (myVideoList.KnowledgeDate[i].Knowledge == myVideoList.SegmentDate[k].Knowledge) {
                    //                myVideoList.KnowledgeDate[i].SegmentDate.push(myVideoList.SegmentDate[k]);
                    //            }
                    //        }
                    //    }else {
                    //        for (var j = 0; j < myVideoList.SegmentDate.length; j++) {
                    //            if (myVideoList.VideoLists[i].VideoChapterName == myVideoList.SegmentDate[j].VideoChapterName) {
                    //                myVideoList.VideoLists[i].KnowledgeDate.push(myVideoList.SegmentDate[j]);
                    //            }
                    //        }
                    //    }
                    //}
                    selectList();
                    console.log(myVideoList.VideoLists)
                    console.log(myVideoList.KnowledgeDate)
                    objtimer = $interval(myVideoList.fnVideoTime, 1000);

                    myVideoList.imgbg = "img/video_bgs.png";

                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        /**
         * 筛选数组 2017/8/17
         */
        function selectList() {
            for (var i = 0; i < myVideoList.VideoLists.length; i++) {
                if (myVideoList.VideoLists[i].Knowledge != null && myVideoList.VideoLists[i].Knowledge != "") {
                    for (var j = 0; j < myVideoList.KnowledgeDate.length; j++) {//筛选章节下课程 加入课程
                        if (myVideoList.VideoLists[i].VideoChapterName == myVideoList.KnowledgeDate[j].VideoChapterName) {
                            myVideoList.VideoLists[i].KnowledgeDate.push(myVideoList.KnowledgeDate[j]);
                        }

                    }
                } else {
                    for (var j = 0; j < myVideoList.SegmentDate.length; j++) {
                        if (myVideoList.VideoLists[i].VideoChapterName == myVideoList.SegmentDate[j].VideoChapterName) {
                            myVideoList.VideoLists[i].KnowledgeDate.push(myVideoList.SegmentDate[j]);
                        }
                    }
                }
            }

            for (var j = 0; j < myVideoList.SegmentDate.length; j++) {
                if (myVideoList.SegmentDate[j].Knowledge != "") {
                    for (var k = 0; k < myVideoList.VideoLists.length; k++) {
                        for (var s = 0; s < myVideoList.VideoLists[k].KnowledgeDate.length; s++) {
                            if (myVideoList.VideoLists[k].KnowledgeDate[s].SegmentDate != undefined) {
                                if (myVideoList.VideoLists[k].KnowledgeDate[s].Knowledge
                                    == myVideoList.SegmentDate[j].Knowledge) {
                                    myVideoList.VideoLists[k].KnowledgeDate[s].SegmentDate.push(myVideoList.SegmentDate[j]);
                                }
                            }
                        }
                    }
                }
            }
        }

        /**
         * 查重
         * @param angument
         * @param aryCourseList
         * @returns {boolean}
         */
        function fnSelectList(angument, aryCourseList, sel) {
            switch (sel) {
                case "VideoChapterName":
                    for (var i = 0; i < aryCourseList.length; i++) {
                        if (aryCourseList[i].VideoChapterName == angument) {
                            return true;
                        }
                    }
                    return false;
                    break;
                case "Knowledge":
                    for (var i = 0; i < aryCourseList.length; i++) {
                        if (aryCourseList[i].Knowledge == angument) {
                            return true;
                        }
                    }
                    return false;
                    break;
            }

        };


        /**
         * 如果时间大于0看过，灰色  反之黑色 2017/8/9
         * @param times
         * @returns {*}
         */
        function isLooks(times) {
            if (times > 0) {
                return "#bfbfbf";
            } else {
                return "#000000";
            }
        }

        /**
         * 定义第一次进入方法
         * @param data
         * @returns {*}
         */
        function fnFirstLearning(data) {
            if (data == undefined) {
                return "";
            } else {
                return data;
            }
        }

        //启动方法
        fnPlayerListGet()
        function fnVideoTime() {
            if (myVideoList.videoItemTime >= 60) {
                myVideoList.videoItemTime = myVideoList.videoItemTime
                myVideoList.fnVideoSaveSet(myVideoList.videoLerningID, myVideoList.VideoID, myVideoList.ContractID, myVideoList.CustomerID);
                //$interval.cancel(objtimer);
                myVideoList.videoItemTime = 0;
                return;
            }
            else if (myVideo.ended) {
                myVideoList.videoItemTime = myVideoList.videoItemTime;
                myVideoList.fnVideoSaveSet(myVideoList.videoLerningID, myVideoList.VideoID, myVideoList.ContractID, myVideoList.CustomerID);
                $interval.cancel(objtimer);
            } else if (myVideo.paused) {
                myVideoList.videoItemTime = myVideoList.videoItemTime;
            }
            else {
                myVideoList.videoItemTime++;
            }
        }

        function fnVideoSaveSet(LearningID, VideoID, ContractID, CustomerID) {
            //loadingService.show();
            myVideoService.FunVideoSaveSet(LearningID, VideoID, ContractID, myVideoList.videoItemTime, CustomerID)
                .then(function (data) {
                    if (data == "CustomerID") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('未登录！');
                        return;
                    }
                    if (data == "error") {
                        loadingService.hide();
                        $cordovaToast.showShortBottom('错误！');
                        return;
                    }
                    myVideoList.videoLerningID = data;
                    //loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }


    }
})()
