/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myVideoCourseListController", myVideoCourseListController);

  function myVideoCourseListController($state, $scope, $location, $cordovaToast, loadingService, myVideoService, accountService) {
    var myVideoCourseList = this;
    myVideoCourseList.fnVideoListGet = fnVideoListGet;//定义方法
    myVideoCourseList.fnGoList = fnGoList;//定义方法
    myVideoCourseList.VideoCourseList = [];//创建新的数组用来接收数据并展示
    myVideoCourseList.customerID = accountService.fnGetUser().CustomerID;//获取customerID
    function fnGoList() {
      $state.go('tab.person');
      //$location.path("tab/person");
    }

    /**
     * 下拉刷新 2017/9/19
     * @type {loadNewerStories}
     */
    myVideoCourseList.loadNewerStories = loadNewerStories;
    function loadNewerStories() {
      myVideoCourseList.VideoCourseList = [];
      fnVideoListGet();
      $scope.$broadcast('scroll.refreshComplete');//广播结束
    }

    myVideoCourseList.isShowImgNull = false;
    /**
     * 请求我的视频列表
     */
    function fnVideoListGet() {
      loadingService.show();
      myVideoService.FunVideoListGet(myVideoCourseList.customerID)
        .then(function (data) {
          if (data[0].length <= 0) {
            myVideoCourseList.isShowImgNull = true;
            //var alertPopup = $ionicPopup.alert({
            //  title: '提示',
            //  template: '暂无视频！'
            //});
            //alertPopup.then(function (res) {
            //  $location.path("/tab/person");
            //});
            loadingService.hide();
            return;
          }
          //console.log(data[0])
          myVideoCourseList.VideoCourseList = data[0];
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //启动方法
    fnVideoListGet();

  }
})()
