/**
 * Created by zjw-pc on 2016/5/16.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("homeController", homeController);

    function homeController($scope, $cordovaFile, $location, $cordovaToast, loadingService, homeService, _customerType, _version) {
        var homeProductIsTop = this;
        homeProductIsTop.isRefresh = false;
        homeProductIsTop.loadNewerStories = loadNewerStories;//刷新
        homeProductIsTop.fnVersionGet = fnVersionGet;//版本号
        //置顶推荐
        homeProductIsTop.fnProductIsTop = fnProductIsTop;
        homeProductIsTop.customerType = false;
        homeProductIsTop.productIsTopList = [];
        //课程信息
        homeProductIsTop.fnSubjectList = fnSubjectList;
        homeProductIsTop.SubjectList = [];
        homeProductIsTop.SubjectColorList = [
            {
                "SubjectID": "a0b27d37-0559-4695-b948-1e031adb82fc",
                "SubjectName": "基金",
                "SubjectShort": "基",
                "SubjectColor": "img/img_jj.png"
            },
            {
                "SubjectID": "30565d81-abc8-4192-9a89-247af4c00265",
                "SubjectName": "经济师",
                "SubjectShort": "经",
                "SubjectColor": "img/img_jjs.png"
            }, {
                "SubjectID": "6f56ba18-7a89-40cd-9304-27a159388ad1",
                "SubjectName": "期货",
                "SubjectShort": "期",
                "SubjectColor": "img/img_qh.png"
            }, {
                "SubjectID": "4bad7c0d-a00f-46db-b09b-4691dce553fe",
                "SubjectName": "银行",
                "SubjectShort": "银",
                "SubjectColor": "img/img_yh.png"
            }, {
                "SubjectID": "a6c2d781-2187-426f-9399-5cf3fc9340a6",
                "SubjectName": "CFA",
                "SubjectShort": "C",
                "SubjectColor": "img/img_cfa.png"
            }, {
                "SubjectID": "6d376160-e3ed-42aa-ae39-89065554735d",
                "SubjectName": "证券",
                "SubjectShort": "证",
                "SubjectColor": "img/img_zq.png"
            }, {
                "SubjectID": "654400fb-7429-4261-be28-8f557aa94911",
                "SubjectName": "会计",
                "SubjectShort": "会",
                "SubjectColor": "img/img_qj.png"
            }, {
                "SubjectID": "7feff67b-9947-464a-a901-e8e96635afe9",
                "SubjectName": "CPA",
                "SubjectShort": "C",
                "SubjectColor": "img/img_cpa.png"
            }

        ];

      homeProductIsTop.test=test;
      function test(){
        cordova.plugins.notification.local.schedule({
          id: 15,
          title: 'Chat with Irish',
          icon: 'img/photo.png',
          text: [
            { message: 'I miss you' },
            { person: 'Irish', message: 'I miss you more!' },
            { message: 'I always miss you more by 10%' }
          ]
        });
      }


//转换公式符号的方法
//    homeProductIsTop.JSONtoEqEd = JSONtoEqEd;
//    function JSONtoEqEd(e) {
//      var jsonObj = $.parseJSON($('#TextJSON').val());
//      var equation = eqEd.Equation.constructFromJsonObj(jsonObj);
//      $('#renderedEq').empty();
//      $('#renderedEq').append(equation.domObj.value);
//      equation.updateAll();
//    };

        homeProductIsTop.videoClick = videoClick;//点击进入播放视频路径
        function videoClick(age) {
            $location.path(age);
        }

        //置顶推荐
        function fnProductIsTop() {
            loadingService.show();
            _customerType = homeProductIsTop.customerType ? 1 : 0;
            homeService.fnHomeProductIsTop()
                .then(function (data) {
                    for (var i = 0; i < data[0].length; i++) {
                        var item = {
                            "Category": data[0][i].Category,
                            "learningTime": data[0][i].learningTime,
                            "ProductID": data[0][i].productID,
                            "ProductName": data[0][i].ProductName,
                            "Picture": data[0][i].Picture
                        }
                        homeProductIsTop.productIsTopList.push(item);
                    }
                    if (homeProductIsTop.isRefresh) {
                        $scope.$broadcast('scroll.refreshComplete');//广播结束
                    }
                    fnVersionGet();
                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });

        }

        //课程信息
        function fnSubjectList() {
            loadingService.show();
            homeService.fnHomeSubjectList()
                .then(function (data) {
                    for (var i = 0; i < data[0].length; i++) {
                        var item = {
                            "SubjectID": data[0][i].SubjectID,
                            "SubjectName": "",//data[0][i].SubjectName
                            "SubjectColor": "",
                            "SubjectShort": ""
                        }
                        homeProductIsTop.SubjectList.push(item);
                        if (homeProductIsTop.SubjectList[i].SubjectID == homeProductIsTop.SubjectColorList[i].SubjectID) {
                            homeProductIsTop.SubjectList[i].SubjectName = homeProductIsTop.SubjectColorList[i].SubjectName;
                            homeProductIsTop.SubjectList[i].SubjectColor = homeProductIsTop.SubjectColorList[i].SubjectColor;
                            homeProductIsTop.SubjectList[i].SubjectShort = homeProductIsTop.SubjectColorList[i].SubjectShort;
                        }

                    }


                    //loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        fnSubjectList();
        fnProductIsTop();
        /**
         * 刷新数据
         */
        function loadNewerStories() {
            homeProductIsTop.SubjectList = [];
            homeProductIsTop.productIsTopList = [];
            homeProductIsTop.isRefresh = true;
            fnSubjectList();
            fnProductIsTop();

        }

        /**
         * 获取版本号
         */
        function fnVersionGet() {
            homeService.fnEditionGet()
                .then(function (datas) {
                    //var serverAppVersion = datas; //从服务端获取最新版本
                    //serverAppVersion = serverAppVersion.replace(/\./g, '');
                    //_version = _version.replace(/\./g, '');
                    //
                    //if (_version < serverAppVersion) {
                    //  $cordovaToast.showLongBottom('您的当前版本过低，请及时更新！');
                    //}

                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }


        //homeProductIsTop.downs = downs;
        //function downs() {
        //  var permissions = cordova.plugins.permissions;
        //  alert(JSON.stringify(permissions));
        //  permissions.hasPermission(permissions.WRITE_EXTERNAL_STORAGE, checkPermissionCallback, null);
        //  function checkPermissionCallback(status) {
        //    if (!status.hasPermission) {
        //      var errorCallback = function () {
        //        alert(' permission is not turned on');
        //      }
        //      permissions.requestPermission(permissions.WRITE_EXTERNAL_STORAGE, function (status) {
        //        if (!status.hasPermission) {
        //          errorCallback();
        //        }
        //        else {
        //          alert('666');
        //        }
        //      }, errorCallback);
        //    }
        //    else{
        //      alert("permission is ok");
        //      alert(cordova.file.externalRootDirectory);
        //
        //    }
        //    $cordovaFile.checkDir(cordova.file.externalRootDirectory, "Download")
        //      .then(function (success) {
        //        alert("find");
        //      }, function (error) {
        //        alert("no find");
        //      });
        //
        //    $cordovaFile.writeFile(cordova.file.externalRootDirectory, "Download/file.txt", "山东矿机疯狂拉升的九分裤裸嫁时代", true)
        //      .then(function (success) {
        //        alert("success" + JSON.stringify(success))
        //        // success
        //      }, function (error) {
        //        // error
        //        alert("error" + JSON.stringify(error))
        //      });
        //  }
        //  //
        //
        //
        //}
    }
})()
