/**
 * Created by zjw-pc on 2016/5/16.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("homeDownListController", homeDownListController);

  function homeDownListController($state, shopService, $scope, $ionicPopover, $window, accountService, $ionicPopup, $location, $stateParams, $cordovaToast, loadingService, homeService) {
    var myVideo = document.getElementById('myVideoHomeDownList');
    var homeDownList = this;
    homeDownList.fnProductInfo = fnProductInfo;
    homeDownList.customerType = false;
    homeDownList.customerTypeList = [];
    homeDownList.productProductID = $stateParams.ProductId;//接收ProductID
    homeDownList.productProductName = $stateParams.ProductName;//ProductName
    homeDownList.introCheckClick = introCheckClick;//简介
    homeDownList.informationCheckClick = informationCheckClick;//产品信息
    homeDownList.htmlDecodeByRegExp = htmlDecodeByRegExp;//HTML解码
    homeDownList.fnGoList = fnGoList;
    homeDownList.isShowIntro = true; //简介显示隐藏
    homeDownList.isShowInformation = false;//产品信息显示隐藏
    homeDownList.introColor = "#27c0d2";
    homeDownList.informationColor = "#dddddd";
    homeDownList.isShowVideo = true;
    homeDownList.isShowImg = false;
    homeDownList.isShowButtomTab = false;//是否显示底部tab按钮
    homeDownList.isShowButtomButton = true;//是否显示底部报名按钮
    //homeDownList.play = play;//定义点击选择方法
    homeDownList.fnGoBill = fnGoBill;//定义进入订单方法
    homeDownList.fnGoHttp = fnGoHttp;//定义立即报名进入链接的方法

    homeDownList.isShowBadge = false;
    if (shopService.fnGetShopCart().length != 0) {
      homeDownList.isShowBadge = true;
      homeDownList.badges = shopService.fnGetShopCart().length;//徽章 2017/9/19
    }
    homeDownList.fnSetShop = fnSetShop;//添加产品进入购物车
    function fnSetShop() {
      if (accountService.fnGetUser().CustomerID == undefined) {
        var alertPopup = $ionicPopup.alert({
          title: '用户验证',
          template: '您尚未有登录系统'
        });
        alertPopup.then(function (res) {
          $location.path("/tab/userLogin");
        });
        return;
      }
      var shopInfo = {
        "ProductID": homeDownList.customerTypeList[0].ProductID,
        "ProductName": homeDownList.customerTypeList[0].ProductName,
        "Amount": homeDownList.customerTypeList[0].Amount
      }
      var List = [];
      List = shopService.fnGetShopCart();
      List.push(shopInfo);
      shopService.fnSetShopCart(List);
      if (shopService.fnGetShopCart().length != 0) {
        homeDownList.isShowBadge = true;
        homeDownList.badges = shopService.fnGetShopCart().length;//徽章 2017/9/19
      }
      $cordovaToast.showShortBottom('添加成功！请到购物车查看！');

    }

    //homeDownList.imgbg = "img/video_bgs.png"; //视频loading 2017/8/22
    homeDownList.popoverShow = popoverShow;//显示协议
    homeDownList.popoverClose = popoverClose;//关闭协议

    homeDownList.isShowPay = true;//2016/8/6 是否显示购买
    homeDownList.customerType = accountService.fnGetCustomerType().customerType;//2016/8/4

    homeDownList.showProcotols = $ionicPopover.fromTemplateUrl('popup-showProcotolsHome.html', {
      scope: $scope
    });
    // .fromTemplateUrl() 方法
    $ionicPopover.fromTemplateUrl('popup-showProcotolsHome.html', {
      scope: $scope
    }).then(function (showProcotols) {
      homeDownList.showProcotolsHome = showProcotols;
    });
    /**
     * 显示协议窗口
     * @param $event
     */
    function popoverShow($event) {
      homeDownList.showProcotolsHome.show($event);
    }

    /**
     * 关闭协议窗口
     * @param $event
     */
    function popoverClose($event) {
      homeDownList.showProcotolsHome.hide();
    }


    function fnGoHttp() {
      $window.open("http://www.lekaowang.cn/Phone.aspx?Url=" + homeProductInfo.customerTypeList[0].GoUrl);
    }

    /**
     * 定义进入订单方法
     */
    function fnGoBill() {
      if (accountService.fnGetUser().CustomerID == undefined) {
        loadingService.hide();
        var alertPopup = $ionicPopup.alert({
          title: '用户验证',
          template: '您尚未有登录系统'
        });
        alertPopup.then(function (res) {
          $location.path("/tab/userLogin");
        });
        return;
      }
      $location.path("/my/bill/" + homeDownList.customerTypeList[0].ProductID + "/0");
    }


    /**
     * 返回
     */
    function fnGoList() {
      //myVideo.pause();
      //$rootScope.$ionicGoBack();
      $state.go('tab.home');
      //$location.path("tab/home");

    }

    function fnProductInfo() {
      loadingService.show();
      homeService.fnHomeProductInfo(homeDownList.productProductID)
        .then(function (data) {
          if (data[0][0].IsOtherProduct == "False") {
            homeDownList.isShowOtherProductTab = true; // 其他的产品 为true时隐藏 2017/12/17
          } else {
            homeDownList.isShowOtherProductTab = false; // 其他的产品 为true时隐藏 2017/12/17
          }

          for (var i = 0; i < data[0].length; i++) {
            var item = {
              "ProductID": data[0][i].ProductID,
              "Category": data[0][i].Category,
              "DetailedProductIntroduction": (data[0][i].DetailedProductIntroduction),
              "learningTime": data[0][i].learningTime,
              "ProductIntroduction": data[0][i].ProductIntroduction,
              "ProductName": data[0][i].ProductName,
              "VideoName": data[0][i].VideoName,
              "VideoPictureURL": data[0][i].VideoPictureURL,
              "TopicQuantity": data[0][i].TopicQuantity,
              "ExamSet": data[0][i].ExamSet,
              "Picture": data[0][i].Picture,
              "CourseCataLog": data[0][i].CourseCataLog,
              "homeDownLists": (data[0][i].homeDownLists),
              "CourseID": data[0][i].CourseID,
              "ChapterID": data[0][i].ChapterID,
              "GoUrl": data[0][i].GoUrl,
              "Agreement": data[0][i].Agreement,
              "Amount": parseFloat(data[0][i].DiscountAmount) > 0 ? data[0][i].DiscountAmount : data[0][i].Amount,//2017/11/15  详情里优惠金额
              "CourseDetails": data[0][i].CourseDetails//2017/11/15  详情修改
            };
            homeDownList.customerTypeList.push(item);
          }
          //homeDownList.play(homeDownList.customerTypeList[0].VideoName);

          if (homeDownList.customerType == 1) {//判断是否为大客户2016/8/4
            if (homeDownList.customerTypeList[0].GoUrl.length == 0) {
              homeDownList.isShowButtomTab = true;
              homeDownList.isShowPay = false;//显示隐藏购买
              homeDownList.isShowButtomButton = false;
            }
          }
          else {

            if (homeDownList.customerTypeList[0].GoUrl.length == 0) {
              homeDownList.isShowButtomTab = true;
              homeDownList.isShowPay = true;//显示隐藏购买
              homeDownList.isShowButtomButton = false;
            }
          }
          homeDownList.setVideoBackground = "";//设置是否有取到视频地址 替换图片
          if (homeDownList.customerTypeList[0].VideoName.length <= 0) {
            homeDownList.setVideoBackground = "img/Video_s.png";
          } else {
            homeDownList.setVideoBackground = "img/video_bg1.png";
          }
          homeDownList.fnPlayVideo = fnPlayVideo;//播放视频方法
          function fnPlayVideo() {
            try {
              window.plugins.streamingMedia.playVideo(homeDownList.customerTypeList[0].VideoName);
            } catch (e) {
              console.log("插件无法在浏览器使用")
            }
          }

          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    fnProductInfo()
    /**
     * 点击选择产品信息，简介
     */
    //简介
    function introCheckClick() {
      homeDownList.isShowIntro = true;
      homeDownList.isShowInformation = false;
      homeDownList.introColor = "#27c0d2";
      homeDownList.informationColor = "#dddddd";
    }

    //产品信息
    function informationCheckClick() {
      homeDownList.isShowIntro = false;
      homeDownList.isShowInformation = true;
      homeDownList.informationColor = "#27c0d2";
      homeDownList.introColor = "#dddddd";
    }

    /**
     * HTML解码
     * @param str
     * @returns {string}
     */
    function htmlDecodeByRegExp(str) {
      var s = "";
      if (str.length == 0) return "";
      s = str.replace(/&amp;/g, "&");
      s = s.replace(/&lt;/g, "<");
      s = s.replace(/&gt;/g, ">");
      s = s.replace(/&nbsp;/g, " ");
      s = s.replace(/&#39;/g, "\'");
      s = s.replace(/&quot;/g, "\"");
      return s;
    }
  }
})()
