/**
 * Created by zjw-pc on 2016/5/16.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("homeProductInfoController", homeProductInfoController);

    function homeProductInfoController($ionicHistory, shopService, $scope, $ionicPopover, $window, accountService, $ionicPopup, $location, $stateParams, $cordovaToast, loadingService, homeService, _customerType) {
        var myVideo = document.getElementById('myVideoListDetail');
        var homeProductInfo = this;
        homeProductInfo.fnProductInfo = fnProductInfo;
        homeProductInfo.customerType = false;
        homeProductInfo.customerTypeList = new Array();
        homeProductInfo.productProductID = $stateParams.ProductID;//接收ProductID
        homeProductInfo.productProductName = $stateParams.ProductName;//ProductName
        homeProductInfo.productSubjectID = $stateParams.SubjectID;//SubjectID
        homeProductInfo.productSubjectName = $stateParams.SubjectName;//SubjectName
        homeProductInfo.introCheckClick = introCheckClick;//简介
        homeProductInfo.informationCheckClick = informationCheckClick;//产品信息
        homeProductInfo.htmlDecodeByRegExp = htmlDecodeByRegExp;//HTML解码
        homeProductInfo.fnGoList = fnGoList;
        homeProductInfo.isShowIntro = true; //简介显示隐藏
        homeProductInfo.isShowInformation = false;//产品信息显示隐藏
        homeProductInfo.introColor = "#27c0d2";
        homeProductInfo.informationColor = "#dddddd";
        homeProductInfo.isShowVideo = true;
        homeProductInfo.isShowImg = false;
        homeProductInfo.isShowButtomTab = false;//是否显示底部tab按钮
        homeProductInfo.isShowButtomButton = true;//是否显示底部报名按钮
        //homeProductInfo.play = play;//定义点击选择方法
        homeProductInfo.fnGoBill = fnGoBill;//定义进入订单方法
        homeProductInfo.fnGoHttp = fnGoHttp;//定义立即报名进入链接的方法

        homeProductInfo.isShowBadge = false;
        if (shopService.fnGetShopCart().length != 0) {
            homeProductInfo.isShowBadge = true;
            homeProductInfo.badges = shopService.fnGetShopCart().length;//徽章 2017/9/19
        }

        homeProductInfo.fnSetShop = fnSetShop;//添加产品进入购物车
        function fnSetShop() {
            if (accountService.fnGetUser().CustomerID == undefined) {
                var alertPopup = $ionicPopup.alert({
                    title: '用户验证',
                    template: '您尚未有登录系统'
                });
                alertPopup.then(function (res) {
                    $location.path("/tab/userLogin");
                });
                return;
            }
            var shopInfo = {
                "ProductID": homeProductInfo.customerTypeList[0].ProductID,
                "ProductName": homeProductInfo.customerTypeList[0].ProductName,
                "Amount": homeProductInfo.customerTypeList[0].Amount
            }
            var List = [];
            List = shopService.fnGetShopCart();
            List.push(shopInfo);
            shopService.fnSetShopCart(List);
            if (shopService.fnGetShopCart().length != 0) {
                homeProductInfo.isShowBadge = true;
                homeProductInfo.badges = shopService.fnGetShopCart().length;//徽章 2017/9/19
            }
            $cordovaToast.showShortBottom('添加成功！请到购物车查看！');

        }

        homeProductInfo.imgbg = "img/video_bgs.png"; //视频loading 2017/8/22

        homeProductInfo.popoverShow = popoverShow;//显示协议
        homeProductInfo.popoverClose = popoverClose;//关闭协议

        homeProductInfo.isShowPay = true;//2016/8/6 是否显示购买
        homeProductInfo.customerType = accountService.fnGetCustomerType().customerType;//2016/8/4


        homeProductInfo.showProcotols = $ionicPopover.fromTemplateUrl('popup-showProcotolsList.html', {
            scope: $scope
        });
        // .fromTemplateUrl() 方法
        $ionicPopover.fromTemplateUrl('popup-showProcotolsList.html', {
            scope: $scope
        }).then(function (showProcotols) {
            homeProductInfo.showProcotolsList = showProcotols;
        });
        /**
         * 显示协议窗口
         * @param $event
         */
        function popoverShow($event) {
            homeProductInfo.showProcotolsList.show($event);
        }

        /**
         * 关闭协议窗口
         * @param $event
         */
        function popoverClose($event) {
            homeProductInfo.showProcotolsList.hide();
        }


        function fnGoHttp() {
            $window.open("http://www.lekaowang.cn/Phone.aspx?Url=" + homeProductInfo.customerTypeList[0].GoUrl);
        }

        /**
         * 定义进入订单方法
         */
        function fnGoBill() {
            if (accountService.fnGetUser().CustomerID == undefined) {
                loadingService.hide();
                var alertPopup = $ionicPopup.alert({
                    title: '用户验证',
                    template: '您尚未有登录系统'
                });
                alertPopup.then(function (res) {
                    $location.path("/tab/userLogin");
                });
                return;
            }
            $location.path("/my/bill/" + homeProductInfo.customerTypeList[0].ProductID + "/0");
        }

        ////监听播放事件 2017/8/22
        //myVideo.addEventListener("play", function () {
        //    homeProductInfo.imgbg = "img/video_loadings.gif"; //视频loading 2017/8/22
        //    homeProductInfo.introCheckClick();//借由刷新页面
        //}, false);


        /**
         * 点击切换视频
         * @param url
         */
        //function play(url) {
        //    myVideo.src = url;
        //    if (url.length < 4) {
        //        homeProductInfo.isShowVideo = false;
        //        homeProductInfo.isShowImg = true;
        //        return
        //    }
        //    //myVideo.play();
        //}

        /**
         * 返回
         */
        function fnGoList() {
            //myVideo.pause();
            $ionicHistory.goBack();
            //$location.path("tab/list/" + homeProductInfo.productSubjectID + "/" + homeProductInfo.productSubjectName);
        }

        function fnProductInfo() {
            loadingService.show();
            _customerType = homeProductInfo.customerType ? 1 : 0;
            homeService.fnHomeProductInfo(homeProductInfo.productProductID)
                .then(function (data) {
                  if (data[0][0].IsOtherProduct == "False") {
                    homeProductInfo.isShowOtherProductTab = true; // 其他的产品 为true时隐藏 2017/12/17
                  } else {
                    homeProductInfo.isShowOtherProductTab = false; // 其他的产品 为true时隐藏 2017/12/17
                  }
                    //console.log("------------------->" + data[0]);
                    for (var i = 0; i < data[0].length; i++) {
                        var item = {
                            "ProductID": data[0][i].ProductID,
                            "Category": data[0][i].Category,
                            "DetailedProductIntroduction": htmlDecodeByRegExp(data[0][i].DetailedProductIntroduction),
                            "learningTime": data[0][i].learningTime,
                            "ProductIntroduction": data[0][i].ProductIntroduction,
                            "ProductName": data[0][i].ProductName,
                            "VideoName": data[0][i].VideoName,
                            "VideoPictureURL": data[0][i].VideoPictureURL,
                            "TopicQuantity": data[0][i].TopicQuantity,
                            "ExamSet": data[0][i].ExamSet,
                            "Picture": data[0][i].Picture,
                            "CourseCataLog": data[0][i].CourseCataLog,
                            "CourseID": data[0][i].CourseID,
                            "ChapterID": data[0][i].ChapterID,
                            "GoUrl": data[0][i].GoUrl,
                            "Agreement": data[0][i].Agreement,
                            "Amount":  parseFloat(data[0][i].DiscountAmount) > 0 ? data[0][i].DiscountAmount : data[0][i].Amount,//2017/11/15  详情里优惠金额
                            "CourseDetails": data[0][i].CourseDetails//2017/11/15  详情修改
                        };
                        homeProductInfo.customerTypeList.push(item);
                    }
                    //homeProductInfo.play(homeProductInfo.customerTypeList[0].VideoName);

                    if (homeProductInfo.customerType == 1) {//判断是否为大客户2016/8/4
                        if (homeProductInfo.customerTypeList[0].GoUrl.length == 0) {
                            homeProductInfo.isShowButtomTab = true;
                            homeProductInfo.isShowPay = false;//显示隐藏购买
                            homeProductInfo.isShowButtomButton = false;
                        }
                    }
                    else {
                        if (homeProductInfo.customerTypeList[0].GoUrl.length == 0) {
                            homeProductInfo.isShowButtomTab = true;
                            homeProductInfo.isShowPay = true;//显示隐藏购买
                            homeProductInfo.isShowButtomButton = false;
                        }
                    }
                  homeProductInfo.setVideoBackground = "";//设置是否有取到视频地址 替换图片
                  if (homeProductInfo.customerTypeList[0].VideoName.length <= 0) {
                    homeProductInfo.setVideoBackground = "img/Video_s.png";
                  } else {
                    homeProductInfo.setVideoBackground = "img/video_bg1.png";
                  }
                  homeProductInfo.fnPlayVideo = fnPlayVideo;//播放视频方法
                  function fnPlayVideo() {
                    try {
                      window.plugins.streamingMedia.playVideo(homeProductInfo.customerTypeList[0].VideoName);
                    } catch (e) {
                      console.log("插件无法在浏览器使用")
                    }
                  }
                    loadingService.hide();
                }, function (error) {
                    $cordovaToast.showShortBottom('网络出现异常！');
                });
        }

        fnProductInfo()
        /**
         * 点击选择产品信息，简介
         */
        //简介
        function introCheckClick() {
            homeProductInfo.isShowIntro = true;
            homeProductInfo.isShowInformation = false;
            homeProductInfo.introColor = "#27c0d2";
            homeProductInfo.informationColor = "#dddddd";
        }

        //产品信息
        function informationCheckClick() {
            homeProductInfo.isShowIntro = false;
            homeProductInfo.isShowInformation = true;
            homeProductInfo.informationColor = "#27c0d2";
            homeProductInfo.introColor = "#dddddd";
        }

        /**
         * HTML解码
         * @param str
         * @returns {string}
         */
        function htmlDecodeByRegExp(str) {
            var s = "";
            if (str.length == 0) return "";
            s = str.replace(/&amp;/g, "&");
            s = s.replace(/&lt;/g, "<");
            s = s.replace(/&gt;/g, ">");
            s = s.replace(/&nbsp;/g, " ");
            s = s.replace(/&#39;/g, "\'");
            s = s.replace(/&quot;/g, "\"");
            return s;
        }
    }
})()
