/**
 * Created by zjw-pc on 2016/5/23.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("wikipediaNewsController", wikipediaNewsController);

  function wikipediaNewsController($ionicPopup,$location, $stateParams, $cordovaToast, loadingService, wikipediaService, _customerType) {
    var wikipediaNews = this;
    wikipediaNews.fnJournalismClientGet = fnJournalismClientGet;//请求新闻详细页方法
    wikipediaNews.JournalismClientGet = "";//用来接收数据
    wikipediaNews.fnGoList = fnGoList;
    wikipediaNews.NewID = $stateParams.newID;
    wikipediaNews.NewTitle = $stateParams.newTitle;
    wikipediaNews.htmlDecodeByRegExp = htmlDecodeByRegExp;//HTML解码
    function fnGoList(){
      $location.path("tab/wikipedia");
    }
    /**
     * 请求新闻列表
     */
    function fnJournalismClientGet() {
      loadingService.show();
      wikipediaService.FunJournalismClientGet(wikipediaNews.NewID)
        .then(function (data) {
          wikipediaNews.JournalismClientGet = data;
          wikipediaNews.JournalismClientGet = wikipediaNews.htmlDecodeByRegExp(wikipediaNews.JournalismClientGet.NewContent);
          //console.log("JournalismClientGet------------------>" + wikipediaNews.NewID + "****wikipediaNews.JournalismClientGet---" + wikipediaNews.JournalismClientGet)
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    fnJournalismClientGet()
    /**
     * HTML解码
     * @param str
     * @returns {string}
     */
    function htmlDecodeByRegExp(str) {
      var s = "";
      if (str.length == 0) return "";
      s = str.replace(/&amp;/g, "&");
      s = s.replace(/&lt;/g, "<");
      s = s.replace(/&gt;/g, ">");
      s = s.replace(/&nbsp;/g, " ");
      s = s.replace(/&#39;/g, "\'");
      s = s.replace(/&quot;/g, "\"");
      return s;
    }

  }
})()
