/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("myReviewService", myReviewService);

  function myReviewService($http, $q, _customerType, _ApiUrl, accountService) {
    var reviewInfo = {};
    //声明方法
    var service = {
      "FunReviewListGet": FunReviewListGet,
      "fnSetReview": fnSetReview,
      "fnGetReview": fnGetReview
    };
    return service;
    /**
     * 获取我的复习列表
     * @param CustomerID
     * @returns {*}
     */
    function FunReviewListGet(CustomerID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CustomerID": CustomerID,
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunReviewListGet" : _ApiUrl.key + "/FunReviewListGet";
      $http.post(postUrl, postData).then(function (result) {
        reviewInfo = result.data.d;
        service.fnSetReview(reviewInfo)
        deferred.resolve(reviewInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }


    function fnGetReview() {
      if (!localStorage.Review) {
        localStorage.Review = JSON.stringify([]);
      }
      return JSON.parse(localStorage.Review);
    }

    function fnSetReview(Review) {
      localStorage.Review = JSON.stringify(Review);
    }
  }
})()

