/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  'use strict';
  angular.module("myApp")
    .factory("myTestService", myTestService);

  function myTestService($http, $q, _customerType, _ApiUrl, accountService) {
    var testInfo = {};
    //声明方法
    var service = {
      "FunSimulationListGet": FunSimulationListGet,
      "fnSetTest": fnSetTest,
      "fnGetTest": fnGetTest
    };
    return service;
    /**
     * 获取我的模拟题列表
     * @param CustomerID
     * @returns {*}
     */
    function FunSimulationListGet(CustomerID) {
      _customerType = accountService.fnGetCustomerType().customerType;//2016/8/4
      var deferred = $q.defer();
      var postData = {
        "CustomerID": CustomerID
      };
      var postUrl = _customerType == 0 ? _ApiUrl.normal + "/FunSimulationListGet" : _ApiUrl.key + "/FunSimulationListGet";
      $http.post(postUrl, postData).then(function (result) {
        testInfo = result.data.d;
        deferred.resolve(testInfo);

      }), function (error) {
        deferred.reject(error);
      }
      return deferred.promise;//回调
    }


    function fnGetTest() {
      if (!localStorage.Test) {
        localStorage.Test = JSON.stringify([]);
      }
      return JSON.parse(localStorage.Test);
    }

    function fnSetTest(Test) {
      localStorage.Test = JSON.stringify(Test);
    }
  }
})()

