/**
 * Created by zjw-pc on 2016/5/16.
 */
(function () {
  angular.module("myApp")
    .controller("changePasswordController", changePasswordController);

  function changePasswordController($location, $stateParams, $cordovaToast, loadingService, accountService, _customerType) {
    var changePassword = this;
    changePassword.fnTelUpdatePasswordSet = fnTelUpdatePasswordSet;//修改密码方法
    changePassword.customerType = false;
    changePassword.Tel = $stateParams.Tel;
    /**
     * 修改密码
     */
    function fnTelUpdatePasswordSet() {
      var code = changePassword.Code;
      var password = changePassword.Password;
      //判断是否为空
      if (code == undefined || password == undefined) {
        $cordovaToast.showShortBottom('电话和验证码不能为空！');
        return;
      }

      loadingService.show();
      _customerType = changePassword.customerType ? 1 : 0;
      accountService.FunTelUpdatePasswordSet(changePassword.Tel, code, password)
        .then(function (data) {
            if (data == "Not") {
              loadingService.hide();
              $cordovaToast.showShortBottom('没有找到！');
              return;
            }
            if (data == "Success") {
              loadingService.hide();
              $cordovaToast.showShortBottom('修改成功！');
              $location.path("tab/userLogin");
              return;
            }
            if (data == "fail") {
              loadingService.hide();
              $cordovaToast.showShortBottom('修改失败！');
              return;
            }
          }, function (error) {
            $cordovaToast.showShortBottom('网络出现异常！');
          }
        );
    }

  }
})()
