/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("boardController", learningboardController);

  function learningboardController($ionicHistory, $timeout, $location, $ionicPopup, $scope, $ionicPopover, $cordovaToast, $stateParams, $interval, loadingService, accountService, learingingBoardService, _customerType) {
    var vm = this;
    vm.CourseCalcTypeID = "";
    var IntFalseSum = 0;//记录会计错误的分数
    var IntTrueSum = 0;//记录会计正确的分数
    var itmArray = 0;//记录会计判断的数目
    var arrRight = [];//半对的分数存入数组
    var tempScore = 0;//计量分数
    var jScore = 0;//经济师多选的单个或漏选计0.5的数
    var my_media = null;
    var objtimer = null;
    vm.currentIndex = 0;
    vm.cQuestionItem = {};
    vm.cAnswerItems = [];
    vm.aryQuestion = [];
    vm.aryAnswer = [];
    vm.contractID = "";
    vm.chapterID = "";
    vm.chapterName = "";
    vm.courseName = "";
    vm.courseID = "";
    vm.myExamPaperID = "";
    vm.myTestPaperID = "";
    vm.freeTestID = "";
    vm.evaluationID = "";
    vm.section = "";
    vm.learningRecordID = "";
    vm.isfirst = "";
    vm.tpicIndex = 0;
    vm.coursetitle = "this is test";
    vm.currentTimes = 0;
    vm.moduleType = "";
    vm.subType = "";
    vm.examPaperID = "";
    vm.arrSelectPanelIndex = [];
    vm.questionMaxNum = 0;
    vm.questionLable = "";
    vm.submitSuccse = false;
    vm.isFinish = 0;//submit exam

    vm.isShowSubmit = false;//显示交卷按钮
    vm.isShowExplain = false;//显示解析按钮
    vm.isSetLabel = false;//显示解析按钮
    vm.isShowWindow = false;//是否显示模板窗口
    vm.isNextReturn = false;//按上一题或下一题后保存完数据disable，true为disable=true
    /**
     * 返回详情所需要的参数
     */
    vm.productID = "";
    vm.productName = "";
    vm.subjectID = "";
    vm.subjectName = "";

    vm.isOk = isOk;
    vm.fnLoadQuestion = fnLoadQuestion;
    vm.fnLoadQuestionItem = fnLoadQuestionItem;
    vm.fnQuestionTimes = fnQuestionTimes;
    vm.fnGetChoice = fnGetChoice;
    vm.fnChangeIndex = fnChangeIndex;//选择改变题目
    vm.popoverShow = popoverShow;//显示选题窗口
    vm.popoverClose = popoverClose;//关闭选题窗口
    vm.popExplainIsShow = popExplainIsShow;//显示解析窗口
    vm.popExplainIsClose = popExplainIsClose;//关闭解析窗口
    vm.choseClick = choseClick;//选择相应的题
    vm.fnQuestionSubmit = fnQuestionSubmit;//交卷
    vm.fnChangeQuestionItemColor = fnChangeQuestionItemColor;//选择套题按钮的颜色判断方法
    vm.fnArrCourseIsNull = fnArrCourseIsNull;//判断是否请求返回数据集
    vm.styleRedTime = {};//time over 300s style
    vm.fnSetLabel = fnSetLabel;
    vm.fnSetQuestion = fnSetQuestion;//插入答疑2017/5/22
    vm.fnGetQuestion = fnGetQuestion;//获取答疑2017/5/22
    //插入答疑2017/5/22
    function fnSetQuestion() {
      learingingBoardService.fnSetAnsweringQuestionSave(vm.cQuestionItem.QuestionID, vm.question)
        .then(function (data) {
          if (data == "") {
            vm.cQuestionItem.getQuestionList = [];//清空数组，答疑读取列表
            vm.fnGetQuestion();//2017/5/22
            $cordovaToast.showShortBottom('提交成功！');
          } else {
            $cordovaToast.showShortBottom(data);
          }
          //loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    vm.cQuestionItem.getQuestionList = [];
    //获取答疑列表2017/5/22
    function fnGetQuestion() {
      learingingBoardService.fnGetAnsweringQuestionList(vm.cQuestionItem.QuestionID)
        .then(function (data) {
          for (var i = 0; i < data[0].length; i++) {
            var item = {
              "AnswerContent": data[0][i].AnswerContent
            };
            vm.cQuestionItem.getQuestionList.push(item);
          }
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    /**
     *  2016/11/16搜索
     */
    vm.fnSearch = fnSearch;//搜索方法
    function fnSearch(str, container) {
      vm.newList = [];//新的列表
      if (str.length < 4) {
        $cordovaToast.showShortBottom('关键字必须四个字以上！');
      }
      var containerList = [];//存储题目的列表
      for (var j = 0; j < container.length; j++) {
        var item = {
          "Topic": container[j].Topic,
          "Index": j
        }
        containerList.push(item);
      }
      var startChar = str.charAt(0); //开始字符
      var strLen = str.length; //查找符串的长度
      for (var i = 0; i < containerList.length; i++) {
        var obj = containerList[i];
        var isMatch = false;
        for (var p in obj) {
          if (typeof (obj[p]) == "function") {
            obj[p]();
          } else {
            var curItem = "";
            if (obj[p] != null) {
              curItem = obj[p];
            }
            for (var j = 0; j < curItem.length; j++) {
              if (curItem.charAt(j) == startChar)//如果匹配起始字符,开始查找
              {
                if (curItem.substring(j).substring(0, strLen) == str)//如果从j开始的字符与str匹配，那ok
                {
                  isMatch = true;
                  break;
                }
              }
            }
          }
        }
        if (isMatch) {
          vm.newList.push(obj);
        }
      }
      if (vm.newList.length == 0) {
        $cordovaToast.showShortBottom('没有查询到您需要的题目！');
      }
      return vm.newList;
    }

    /**
     * 左右滑动触发事件进行下一题
     */
    $scope.onSwipeRight = function () {
      vm.fnChangeIndex(false);
    };

    $scope.onSwipeLeft = function () {
      vm.fnChangeIndex(true);
    };

    /**
     * 选题弹窗
     */
    vm.popover = $ionicPopover.fromTemplateUrl('popup-select.html', {
      scope: $scope
    });
    // .fromTemplateUrl() 方法
    $ionicPopover.fromTemplateUrl('popup-select.html', {
      scope: $scope
    }).then(function (popover) {
      vm.popover = popover;
    });
    /**
     * 显示选题窗口
     * @param $event
     */
    function popoverShow($event) {
      vm.popover.show($event);
    }

    /**
     * 关闭选题窗口
     * @param $event
     */
    function popoverClose($event) {
      vm.popover.hide();
    }

    /**
     * 解析弹窗
     */
    vm.popExplain = $ionicPopover.fromTemplateUrl('popup-explain.html', {
      scope: $scope
    });
    // .fromTemplateUrl() 方法
    $ionicPopover.fromTemplateUrl('popup-explain.html', {
      scope: $scope
    }).then(function (popover) {
      vm.popExplain = popover;
    });
    /**
     * 显示解析窗口
     * @param $event
     */
    function popExplainIsShow($event) {
      vm.cQuestionItem.getQuestionList = [];
      vm.fnGetQuestion();//启动获取答疑列表2017/5/22
      vm.popExplain.show($event);
    }

    /**
     * 关闭解析窗口
     * @param $event
     */
    function popExplainIsClose($event) {
      vm.popExplain.hide();
    }

    /**
     * 选择改变题目
     * @param change
     * @returns {number|*}
     */
    function fnChangeIndex(change, evt) {
      vm.cQuestionItem.getQuestionList = [];
      //vm.fnGetQuestion();//启动获取答疑列表2017/5/22
      //防止连点
      if (vm.isNextReturn) {
        evt.preventDefault();
        evt.stopImmediatePropagation();
      } else {
        vm.isNextReturn = true;
        $timeout(function () {
          vm.isNextReturn = false;
        }, 500, false);
      }
      switch (vm.moduleType) {
        case "chapter":
          switch (vm.subType) {
            case "normal":
              if (change) {
                if (vm.currentIndex == vm.aryQuestion.length - 1) {
                  //vm.isNextReturn = true;
                  vm.fnQuestionSubmit();
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                //alert("----1------"+vm.isNextReturn)
                vm.fnQuestionSubmit();
                //alert("----1------"+vm.isNextReturn)
                $timeout(function () {
                  vm.currentIndex++;
                  vm.fnLoadQuestionItem();
                }, 50, false);
                return false;
              }
              else {
                if (vm.currentIndex == 0) {
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex--;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              break;
            case "label":
              if (change) {
                if (vm.currentIndex == vm.aryQuestion.length - 1) {
                  //vm.isNextReturn = true;
                  vm.fnQuestionSubmit();
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex++;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              else {
                if (vm.currentIndex == 0) {
                  vm.fnLoadQuestionItem();
                  //vm.isNextReturn = false;
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex--;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              break;
            case "error":
              if (change) {
                if (vm.currentIndex == vm.aryQuestion.length - 1) {
                  //vm.isNextReturn = true;
                  vm.fnQuestionSubmit();
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex++;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              else {
                if (vm.currentIndex == 0) {
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex--;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              break;
          }
          break;
        case "exam":
          switch (vm.subType) {
            case "normal":
              if (change) {
                if (vm.currentIndex == vm.aryQuestion.length - 1) {
                  if (vm.isFinish == 0) {
                    //vm.isNextReturn = true;
                    vm.fnQuestionSubmit(1);
                    vm.fnLoadQuestionItem();
                  }
                  else {
                    //vm.isNextReturn = true;
                    vm.fnQuestionSubmit();
                    vm.fnLoadQuestionItem();
                  }
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex++;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              else {
                if (vm.currentIndex == 0) {
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex--;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              break;
            case "label":
              if (change) {
                if (vm.currentIndex == vm.aryQuestion.length - 1) {
                  //vm.isNextReturn = true;
                  vm.fnQuestionSubmit();
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex++;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              else {
                if (vm.currentIndex == 0) {
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex--;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              break;
            case "error":
              if (change) {
                if (vm.currentIndex == vm.aryQuestion.length - 1) {
                  //vm.isNextReturn = true;
                  vm.fnQuestionSubmit();
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex++;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              else {
                if (vm.currentIndex == 0) {
                  vm.fnLoadQuestionItem();
                  return null;
                }
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                $timeout(function () {
                  vm.currentIndex--;
                  vm.fnLoadQuestionItem();
                }, 50, false);
              }
              break;
          }
          break;
        case "test":
          if (change) {
            if (vm.currentIndex == vm.aryQuestion.length - 1) {
              if (vm.isFinish == 0) {
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit(1);
                vm.fnLoadQuestionItem();
              }
              else {
                //vm.isNextReturn = true;
                vm.fnQuestionSubmit();
                vm.fnLoadQuestionItem();
              }
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex++;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          else {
            if (vm.currentIndex == 0) {
              vm.fnLoadQuestionItem();
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex--;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          break;
        case "review":
          if (change) {
            if (vm.currentIndex == vm.aryQuestion.length - 1) {
              //vm.isNextReturn = true;
              vm.fnQuestionSubmit();
              vm.fnLoadQuestionItem();
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex++;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          else {
            if (vm.currentIndex == 0) {
              vm.fnLoadQuestionItem();
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex--;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          break;
        case "trial":
          if (change) {
            if (vm.currentIndex == vm.aryQuestion.length - 1) {
              //vm.isNextReturn = true;
              vm.fnQuestionSubmit();
              vm.fnLoadQuestionItem();
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex++;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          else {
            if (vm.currentIndex == 0) {
              vm.fnLoadQuestionItem();
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex--;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          break;
        case "evaluation":
          if (change) {
            if (vm.currentIndex == vm.aryQuestion.length - 1) {
              //vm.isNextReturn = true;
              vm.fnQuestionSubmit(1);
              vm.fnLoadQuestionItem();
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex++;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          else {
            if (vm.currentIndex == 0) {
              vm.fnLoadQuestionItem();
              return null;
            }
            //vm.isNextReturn = true;
            vm.fnQuestionSubmit();
            $timeout(function () {
              vm.currentIndex--;
              vm.fnLoadQuestionItem();
            }, 50, false);
          }
          break;

      }
      //
      // if (change) {
      //   if (vm.currentIndex > maxNum - 2) {
      //     vm.currentIndex = vm.currentIndex;
      //     //vm.fnLoadQuestion();
      //   } else {
      //     vm.currentIndex = vm.currentIndex + 1;
      //     //vm.fnLoadQuestion();
      //   }
      // } else {
      //   vm.currentIndex = vm.currentIndex - 1;
      //   if (vm.currentIndex < 0) {
      //     vm.currentIndex = 0;
      //   }
      //   //vm.fnLoadQuestion();
      // }
      // fnLoadQuestionItem();
      //        break;
      //      case "label":
      //        break;
      //      case "error":
      //        break;
      //    }
      //    break;
      //}


    }

    /**
     * 选择相应的题
     * @param choseIndex
     */
    function choseClick(choseIndex) {
      if (vm.newList != undefined && vm.newList.length > 0) {//2016/11/16搜索
        vm.newList = [];
      }
      switch (vm.moduleType) {// 加switch 2017/6/2
        case "chapter":
          if (vm.subjectName.length <= 0) {//2017/5/25 不是继续学习不提交 2017/6/2
            vm.fnQuestionSubmit();
          }
          break;
        case "exam":
          vm.fnQuestionSubmit();
          break;
      }
      vm.currentIndex = choseIndex - 1;
      vm.fnLoadQuestionItem();
      popoverClose();
    }

    /**
     * 改变选题的状态颜色
     * @param isLabel
     * @param isRight
     * @returns {Array}
     */
    function fnChangeQuestionItemColor(isLabel, isRight, ChoiceID) {
      var colorArr = [];
      switch (vm.moduleType) {
        case "chapter":
          switch (vm.subType) {
            case "normal":
              //补全条件 2017/6/12
              if (ChoiceID == "") {
                ChoiceID = undefined;
              }

              if (ChoiceID == undefined && isRight != undefined) {
                isRight = undefined;
              }

              isLabel = parseInt(isLabel);//把类型转换为int 2017/6/2
              //未作 有标注  无正确显示
              if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 无标注 无正确显示
              else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 错了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 对了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 对了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 错了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }

              break;
            case "label":
              //未作 有标注  无正确显示
              if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 无标注 无正确显示
              else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 错了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 对了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 对了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 错了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已作 有标注
              else if (ChoiceID != undefined && isLabel == 1) {
                var item = {
                  "borderColor": "#ffffff",
                  "textColor": "#000000",
                  "backgroundColor": "#c2c2c2",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已作 无标注
              else if (ChoiceID != undefined && isLabel == 0) {
                var item = {
                  "borderColor": "#ffffff",
                  "textColor": "#000000",
                  "backgroundColor": "#c2c2c2",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 有标注
              else if (ChoiceID == undefined && isLabel == 1) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 无标注
              else if (ChoiceID == undefined && isLabel == 0) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              break;
            case "error":
              //未作 有标注  无正确显示
              if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 无标注 无正确显示
              else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 错了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 对了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 对了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 错了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已作 有标注
              else if (ChoiceID != undefined && isLabel == 1) {
                var item = {
                  "borderColor": "#ffffff",
                  "textColor": "#000000",
                  "backgroundColor": "#c2c2c2",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已作 无标注
              else if (ChoiceID != undefined && isLabel == 0) {
                var item = {
                  "borderColor": "#ffffff",
                  "textColor": "#000000",
                  "backgroundColor": "#c2c2c2",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 有标注
              else if (ChoiceID == undefined && isLabel == 1) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 无标注
              else if (ChoiceID == undefined && isLabel == 0) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              break;
          }
          break;
        case "exam":
          switch (vm.subType) {
            case "normal":
              //交卷情况下
              if (vm.isFinish == 1) {
                isLabel = parseInt(isLabel);//把类型转换为int 2017/6/2
                isRight = parseInt(isRight);//把类型转换为int 2017/6/2
                if (ChoiceID == "") {
                  ChoiceID = undefined;
                }
                //未做 无标注
                if (ChoiceID == undefined && isLabel == 0) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": ""
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //未做 标注
                if (ChoiceID == undefined && isLabel == 1) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": "star"
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //已做 无标注 错了
                if (ChoiceID != undefined && isLabel == 0 && isRight == 0) {
                  var item = {
                    "borderColor": "#de5c50",
                    "textColor": "#de5c50",
                    "backgroundColor": "#ffffff",
                    "star": ""
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //已做 无标注 对了
                else if (ChoiceID != undefined && isLabel == 0 && isRight == 1) {
                  var item = {
                    "borderColor": "#0996CE",
                    "textColor": "#0996CE",
                    "backgroundColor": "#ffffff",
                    "star": ""
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //已做 标注 对了
                else if (ChoiceID != undefined && isLabel == 1 && isRight == 1) {
                  var item = {
                    "borderColor": "#0996CE",
                    "textColor": "#0996CE",
                    "backgroundColor": "#ffffff",
                    "star": "star"
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //已做 标注 错了
                else if (ChoiceID != undefined && isLabel == 1 && isRight == 0) {
                  var item = {
                    "borderColor": "#de5c50",
                    "textColor": "#de5c50",
                    "backgroundColor": "#ffffff",
                    "star": "star"
                  }
                  colorArr.push(item);
                  return colorArr;
                }
              }
              else {
                //补全条件 2017/6/12
                if (ChoiceID == "") {
                  ChoiceID = undefined;
                }
                if (isRight == "") {
                  isRight = undefined;
                }
                //未作 有标注  无正确显示
                if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": "star"
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //未作 无标注 无正确显示
                else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": ""
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                if (ChoiceID != undefined) {// 2017/6/2
                  //已作 有标注
                  if (ChoiceID.length > 4 && isLabel == 1) {// 2017/5/31
                    var item = {
                      "borderColor": "#ffffff",
                      "textColor": "#000000",
                      "backgroundColor": "#c2c2c2",
                      "star": "star"
                    }
                    colorArr.push(item);
                    return colorArr;
                  }
                  //已作 无标注
                  else if (ChoiceID.length > 4 && isLabel == 0) {// 2017/5/31
                    var item = {
                      "borderColor": "#ffffff",
                      "textColor": "#000000",
                      "backgroundColor": "#c2c2c2",
                      "star": ""
                    }
                    colorArr.push(item);
                    return colorArr;
                  }
                }
                //未作 有标注
                else if (ChoiceID == undefined && isLabel == 1) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": "star"
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //未作 无标注
                else if (ChoiceID == undefined && isLabel == 0) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": ""
                  }
                  colorArr.push(item);
                  return colorArr;
                }

                //未作 有标注 继续学习版 2017/5/31
                else if (ChoiceID == "" && isLabel == 1) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": "star"
                  }
                  colorArr.push(item);
                  return colorArr;
                }
                //未作 无标注 继续学习版 2017/5/31
                else if (ChoiceID == "" && isLabel == 0) {
                  var item = {
                    "borderColor": "#c2c2c2",
                    "textColor": "#c2c2c2",
                    "backgroundColor": "#ffffff",
                    "star": ""
                  }
                  colorArr.push(item);
                  return colorArr;
                }
              }
              break;
            case "label":
              //未作 有标注  无正确显示
              if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 无标注 无正确显示
              else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 错了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 对了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 对了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 错了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              break;
            case "error":
              //未作 有标注  无正确显示
              if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //未作 无标注 无正确显示
              else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
                var item = {
                  "borderColor": "#c2c2c2",
                  "textColor": "#c2c2c2",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 错了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 无标注 对了
              else if (ChoiceID != undefined && isLabel == 0 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": ""
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 对了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 1) {
                var item = {
                  "borderColor": "#0996CE",
                  "textColor": "#0996CE",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              //已做 标注 错了
              else if (ChoiceID != undefined && isLabel == 1 && isRight == 0) {
                var item = {
                  "borderColor": "#de5c50",
                  "textColor": "#de5c50",
                  "backgroundColor": "#ffffff",
                  "star": "star"
                }
                colorArr.push(item);
                return colorArr;
              }
              break;
          }
          break;
        case "test":
          //交卷情况下
          if (vm.isFinish == 1) {
            isLabel = parseInt(isLabel);//把类型转换为int 2017/6/2
            //已做 无标注 错了
            if (ChoiceID != undefined && isLabel == 0 && isRight == 0) {
              var item = {
                "borderColor": "#de5c50",
                "textColor": "#de5c50",
                "backgroundColor": "#ffffff",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
            //已做 无标注 对了
            else if (ChoiceID != undefined && isLabel == 0 && isRight == 1) {
              var item = {
                "borderColor": "#0996CE",
                "textColor": "#0996CE",
                "backgroundColor": "#ffffff",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
            //已做 标注 对了
            else if (ChoiceID != undefined && isLabel == 1 && isRight == 1) {
              var item = {
                "borderColor": "#0996CE",
                "textColor": "#0996CE",
                "backgroundColor": "#ffffff",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //已做 标注 错了
            else if (ChoiceID != undefined && isLabel == 1 && isRight == 0) {
              var item = {
                "borderColor": "#de5c50",
                "textColor": "#de5c50",
                "backgroundColor": "#ffffff",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //未作 有标注  无正确显示
            else if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //未作 无标注 无正确显示
            else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
            //已作 有标注
            else if (ChoiceID != undefined && isLabel == 1) {
              var item = {
                "borderColor": "#ffffff",
                "textColor": "#000000",
                "backgroundColor": "#c2c2c2",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //已作 无标注
            else if (ChoiceID != undefined && isLabel == 0) {
              var item = {
                "borderColor": "#ffffff",
                "textColor": "#000000",
                "backgroundColor": "#c2c2c2",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
            //未作 有标注
            else if (ChoiceID == undefined && isLabel == 1) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //未作 无标注
            else if (ChoiceID == undefined && isLabel == 0) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
          }
          else {
            //未作 有标注  无正确显示
            if (ChoiceID == undefined && isLabel == 1 && isRight == undefined) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //未作 无标注 无正确显示
            else if (ChoiceID == undefined && isLabel == 0 && isRight == undefined) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
            //已作 有标注
            if (ChoiceID != undefined && isLabel == 1) {
              var item = {
                "borderColor": "#ffffff",
                "textColor": "#000000",
                "backgroundColor": "#c2c2c2",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //已作 无标注
            else if (ChoiceID != undefined && isLabel == 0) {
              var item = {
                "borderColor": "#ffffff",
                "textColor": "#000000",
                "backgroundColor": "#c2c2c2",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
            //未作 有标注
            else if (ChoiceID == undefined && isLabel == 1) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": "star"
              }
              colorArr.push(item);
              return colorArr;
            }
            //未作 无标注
            else if (ChoiceID == undefined && isLabel == 0) {
              var item = {
                "borderColor": "#c2c2c2",
                "textColor": "#c2c2c2",
                "backgroundColor": "#ffffff",
                "star": ""
              }
              colorArr.push(item);
              return colorArr;
            }
          }
          break;
        case "review":
          isLabel = parseInt(isLabel);//把类型转换为int 2017/6/2
          if (isRight == "False") {
            isRight = false;
          } else if (isRight == "True") {
            isRight = true;
          }
          //未作 有标注  错
          if (ChoiceID == "" && isLabel == 1 && isRight == false) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          //未作 无标注 错
          else if (ChoiceID == "" && isLabel == 0 && isRight == false) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          //未作 有标注  对
          if (ChoiceID == "" && isLabel == 1 && isRight == true) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          //未作 无标注 对
          else if (ChoiceID == "" && isLabel == 0 && isRight == true) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          //已做 无标注 错了
          else if (ChoiceID != "" && isLabel == 0 && isRight == 0) {
            var item = {
              "borderColor": "#de5c50",
              "textColor": "#de5c50",
              "backgroundColor": "#ffffff",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          //已做 无标注 对了
          else if (ChoiceID != "" && isLabel == 0 && isRight == 1) {
            var item = {
              "borderColor": "#0996CE",
              "textColor": "#0996CE",
              "backgroundColor": "#ffffff",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          //已做 标注 对了
          else if (ChoiceID != "" && isLabel == 1 && isRight == 1) {
            var item = {
              "borderColor": "#0996CE",
              "textColor": "#0996CE",
              "backgroundColor": "#ffffff",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          //已做 标注 错了
          else if (ChoiceID != "" && isLabel == 1 && isRight == 0) {
            var item = {
              "borderColor": "#de5c50",
              "textColor": "#de5c50",
              "backgroundColor": "#ffffff",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          break;
        case "trial":
          //已作 有标注
          if (ChoiceID != "" && isLabel == 1) {
            var item = {
              "borderColor": "#ffffff",
              "textColor": "#000000",
              "backgroundColor": "#c2c2c2",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          //已作 无标注
          else if (ChoiceID != "" && isLabel == 0) {
            var item = {
              "borderColor": "#ffffff",
              "textColor": "#000000",
              "backgroundColor": "#c2c2c2",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          //未作 有标注
          else if (ChoiceID == "" && isLabel == 1) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          //未作 无标注
          else if (ChoiceID == "" && isLabel == 0) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          break;
        case "evaluation":
          //已作 有标注
          if (ChoiceID != "" && isLabel == 1) {
            var item = {
              "borderColor": "#ffffff",
              "textColor": "#000000",
              "backgroundColor": "#c2c2c2",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          //已作 无标注
          else if (ChoiceID != "" && isLabel == 0) {
            var item = {
              "borderColor": "#ffffff",
              "textColor": "#000000",
              "backgroundColor": "#c2c2c2",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          //未作 有标注
          else if (ChoiceID == "" && isLabel == 1) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": "star"
            }
            colorArr.push(item);
            return colorArr;
          }
          //未作 无标注
          else if (ChoiceID == "" && isLabel == 0) {
            var item = {
              "borderColor": "#c2c2c2",
              "textColor": "#c2c2c2",
              "backgroundColor": "#ffffff",
              "star": ""
            }
            colorArr.push(item);
            return colorArr;
          }
          break;
      }
    }

    /**
     * 判断是否请求返回数据集
     * @param data
     * @returns {number}
     */
    function fnArrCourseIsNull(data) {
      var alertPopup;
      //判断没有题目时进行提示
      if (data.length <= 0) {
        loadingService.hide();
        alertPopup = $ionicPopup.alert({
          title: '提示',
          template: "题目正在更新中！"
        }).then(function (res) {
          vm.isOk();
        });
        return 1;
      }
      switch (vm.moduleType) {
        case "chapter":
          if (data == "CustomerID") {// CustomerID用户id空，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户id空！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "Termination") {// Termination合同终止，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "合同终止！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RemainderTime") {// RemainderTime时间由用尽，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "时间已用尽！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isClosed") {// isClosed课程已关闭，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已关闭！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isFreezed") {// isFreezed课程已冻结，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已冻结！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RealName") {// RealName未填写姓名，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户未填写姓名！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "IdentityCard") {// IdentityCard未填写身份
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未填写身份！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "NotContract") {// 没有找到合同
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "没有找到合同！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data[0].length == 0 && data[1].length == 0) {// 未找到相关题目
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未找到相关题目！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          }
          else if (data[1].length > 0 || data[0].length > 0) {//数组中有数值
            return 0;
          }
          break;
        case "exam":
          if (data == "CustomerID") {// CustomerID用户id空，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户id空！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "Termination") {// Termination合同终止，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "合同终止！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RemainderTime") {// RemainderTime时间由用尽，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "时间已用尽！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isClosed") {// isClosed课程已关闭，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已关闭！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isFreezed") {// isFreezed课程已冻结，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已冻结！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RealName") {// RealName未填写姓名，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户未填写姓名！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "IdentityCard") {// IdentityCard未填写身份
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未填写身份！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "NotContract") {// 没有找到合同
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "没有找到合同！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data[0].length == 0 && data[1].length == 0) {// 未找到相关题目
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未找到相关题目！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          }
          else if (data[1].length > 0 || data[0].length > 0) {//数组中有数值
            return 0;
          }
          break;
        case "test":
          if (data == "CustomerID") {// CustomerID用户id空，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户id空！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "Termination") {// Termination合同终止，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "合同终止！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RemainderTime") {// RemainderTime时间由用尽，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "时间已用尽！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isClosed") {// isClosed课程已关闭，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已关闭！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isFreezed") {// isFreezed课程已冻结，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已冻结！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RealName") {// RealName未填写姓名，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户未填写姓名！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "IdentityCard") {// IdentityCard未填写身份
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未填写身份！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "NotContract") {// 没有找到合同
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "没有找到合同！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data.length == 0) {// 未找到相关题目
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未找到相关题目！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          }
          else if (data[0].length == 0 && data[1].length == 0) {// 未找到相关题目
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未找到相关题目！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          }

          else if (data[1].length > 0 || data[0].length > 0) {//数组中有数值
            return 0;
          }
          break;
        case "review":
          if (data == "CustomerID") {// CustomerID用户id空，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户id空！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "Termination") {// Termination合同终止，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "合同终止！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RemainderTime") {// RemainderTime时间由用尽，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "时间已用尽！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isClosed") {// isClosed课程已关闭，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已关闭！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isFreezed") {// isFreezed课程已冻结，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已冻结！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RealName") {// RealName未填写姓名，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户未填写姓名！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "IdentityCard") {// IdentityCard未填写身份
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未填写身份！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "0days") {// 不需要复习
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "不需要复习！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "NotContract") {// 没有找到合同
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "没有找到合同！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data[0].length == 0 && data[1].length == 0) {// 未找到相关题目
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未找到相关题目！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          }
          else if (data[1].length > 0 || data[0].length > 0) {//数组中有数值
            return 0;
          }
          break;
        case "trial":
          if (data == "CustomerID") {// CustomerID用户id空，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户id空！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "Termination") {// Termination合同终止，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "合同终止！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RemainderTime") {// RemainderTime时间由用尽，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "时间已用尽！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isClosed") {// isClosed课程已关闭，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已关闭！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "isFreezed") {// isFreezed课程已冻结，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "课程已冻结！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "RealName") {// RealName未填写姓名，
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "用户未填写姓名！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data == "IdentityCard") {// IdentityCard未填写身份
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未填写身份！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data.length < 1) {// 本课程暂不提供免费试用
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "本课程暂不提供免费试用！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          } else if (data[0].length == 0 && data[1].length == 0) {// 未找到相关题目
            loadingService.hide();
            alertPopup = $ionicPopup.alert({
              title: '提示',
              template: "未找到相关题目！"
            }).then(function (res) {
              vm.isOk();
            });
            return 1;
          }
          else if (data[1].length > 0 || data[0].length > 0) {//数组中有数值
            return 0;
          }
          break;
      }
    }

    /**
     * 进入路由
     */
    function isOk() {
      $ionicHistory.goBack();
    }

    vm.playAudio = playAudio;
    vm.isPlayAudio = false;
    vm.redioSrc = "img/lb.png"
    /**
     *播放音频2016/11/14
     * @param url
     */
    function playAudio(url) {
      if (my_media == null) {
        //alert("url:" + url)
        my_media = new Media(url,
          // success callback
          function () {
            //alert("playAudio():Audio Success");
          },
          // error callback
          function (err) {
            //alert("playAudio():Audio Error: " + err.code);
          }
        );
      }
      vm.isPlayAudio = !vm.isPlayAudio;
      if (vm.isPlayAudio) {
        vm.redioSrc = "img/lbl.png"
        // Play audio
        my_media.play();
      } else {
        vm.redioSrc = "img/lb.png"
        my_media.pause();
      }

    }

    // 在隐藏浮动框后执行
    $scope.$on('popover.hidden', function () {
      vm.redioSrc = "img/lb.png"
      // 执行代码
      if (my_media != null) {
        my_media.stop();
        my_media.release();
      }
      my_media = null;//播放音频情况2017/5/24
    });


    vm.fnIsNextTest = fnIsNextTest;//继续做题 2017/5/24
    function fnIsNextTest(arr) {
      switch (vm.moduleType) {
        case "chapter":
          for (var i = 0; i < arr.length; i++) {
            if (vm.subjectName == arr[i].QuestionID) {
              vm.choseClick(i + 1);
            }
          }
          break;
        case "exam":// 押题继续做题 2017/6/1
          if (vm.subjectName != "") {
            for (var j = arr.length - 1; j >= 0; j--) { //倒叙查找最后的那个选择的问题
              if (arr[j].ChoiceID.length > 4) {
                vm.choseClick(j + 1);
                break;
              }
            }
          }
          break;
      }


    }

    /**
     * 总题量和小题量的区分 2017/10/24
     * @type {fnSum}
     */
    vm.fnSum = fnSum;
    vm.sumAll = 0;
    function fnSum(QuestionInfo) {
      var sumTpicnum = 0;
      var tempQuestion = [];
      for (var i = 0; i < QuestionInfo[1].length; i++) {
        var isgroupID = false;
        for (var g = 0; g < tempQuestion.length; g++) {
          if (tempQuestion[g] == QuestionInfo[1][i].GroupID) {
            isgroupID = true;
            break;
          }
        }
        if (isgroupID) {
          continue;
        }
        if (parseInt(QuestionInfo[1][i].GroupID) != 0 && QuestionInfo[1][i].GroupID != "") {
          tempQuestion.push(QuestionInfo[1][i].GroupID);
        } else {
          sumTpicnum++;
        }
      }
      vm.sumAll = (sumTpicnum + tempQuestion.length);

    }

    //load question   9
    function fnLoadQuestion() {
      loadingService.show();
      vm.contractID = $stateParams.ContractID;
      vm.chapterID = $stateParams.ChapterID;
      vm.chapterName = $stateParams.ChapterName;
      vm.courseName = $stateParams.CourseName;
      vm.courseID = $stateParams.CourseID;
      vm.tpicIndex = $stateParams.TpicIndex - 1;
      vm.examPaperID = $stateParams.examPaperID;
      vm.moduleType = $stateParams.moduleType;//"exam";
      vm.subType = $stateParams.subType;//"normal";

      vm.productID = $stateParams.ProductID;
      vm.productName = $stateParams.ProductName;
      vm.subjectID = $stateParams.SubjectID;
      vm.subjectName = $stateParams.SubjectName;//继续学校的题目 暂代questionID 2017/5/24   也代MyExamPaperID 2017/5/31

      learingingBoardService.MyExamPaperID = vm.subjectName;//SubjectName暂时替代 MyExamPaperID以避免修改路由2017/5/31
      learingingBoardService.segmentID = vm.productID;//cfa暂时替代SegmentID（cfa小结id），以避免修改路由
      learingingBoardService.tpicEnd = vm.productName;//cfa暂时替代TpicEnd（cfa题数），以避免修改路由
      learingingBoardService.contractID = vm.contractID;
      learingingBoardService.chapterID = vm.chapterID;
      learingingBoardService.chapterName = vm.chapterName;
      learingingBoardService.courseID = vm.courseID;
      learingingBoardService.cIndex = vm.tpicIndex;
      learingingBoardService.examPaperID = vm.examPaperID;
      learingingBoardService.moduleType = vm.moduleType;
      learingingBoardService.subType = vm.subType;
      vm.ChapterName = $stateParams.chapterName;
      if (accountService.fnGetUser().CustomerID == undefined) {
        loadingService.hide();
        var alertPopup = $ionicPopup.alert({
          title: '用户验证',
          template: '您尚未有登录系统'
        });
        alertPopup.then(function (res) {
          $location.path("/tab/userLogin");
        });
        return;
      }
      //判断是否在线
      accountService.OnlineState(accountService.fnGetUser().loginCode,
        accountService.fnGetUser().CustomerID)
        .then(function (data) {
          if (data == 0) {//0不在线，1在线
            loadingService.hide();
            localStorage.clear();
            var alertPopup = $ionicPopup.alert({
              title: '用户验证',
              template: '您的账号在其他设备登录，请重新登录！'
            });
            alertPopup.then(function (res) {
              $location.path("/tab/userLogin");
            });
            return;
          }
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
      learingingBoardService.fnLoadQuestionList()
        .then(function (data) {
          switch (vm.moduleType) {
            case "chapter":
              switch (vm.subType) {
                case "normal":
                  if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                    return;
                  }
                  vm.isShowWindow = true;
                  vm.aryQuestion = data[0];
                  vm.aryAnswer = data[1];
                  vm.isShowExplain = true;
                  vm.fnLoadQuestionItem();
                  vm.fnIsNextTest(vm.aryQuestion);//2017/5/24 继续学习
                  vm.questionMaxNum = vm.aryQuestion.length;
                  break;
                case "label":
                  if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                    return;
                  }
                  vm.isShowWindow = true;
                  vm.aryQuestion = data[0];
                  vm.aryAnswer = data[1];
                  vm.isShowExplain = true;
                  vm.fnLoadQuestionItem();
                  vm.questionMaxNum = vm.aryQuestion.length;
                  break;
                case "error":
                  if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                    return;
                  }
                  vm.isShowWindow = true;
                  vm.aryQuestion = data[0];
                  vm.aryAnswer = data[1];
                  vm.isShowExplain = true;
                  vm.fnLoadQuestionItem();
                  vm.questionMaxNum = vm.aryQuestion.length;
                  break;
              }
              break;
            case "exam":
              switch (vm.subType) {
                case "normal":
                  if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                    return;
                  }
                  vm.isShowWindow = true;
                  vm.fnSum(data);//总题量和小题量的区分 2017/10/24
                  vm.myExamPaperID = data[0][0].MyExamPaperID;
                  vm.aryQuestion = data[1];
                  vm.aryAnswer = data[2];
                  vm.isShowSubmit = true;
                  vm.fnLoadQuestionItem();
                  vm.fnIsNextTest(vm.aryQuestion);//2017/6/1 押题继续学习
                  vm.questionMaxNum = vm.aryQuestion.length;
                  break;
                case "label":
                  if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                    return;
                  }
                  vm.isShowWindow = true;
                  vm.aryQuestion = data[0];
                  vm.aryAnswer = data[1];
                  vm.isShowExplain = true;
                  vm.fnLoadQuestionItem();
                  vm.questionMaxNum = vm.aryQuestion.length;
                  break;
                case "error":
                  if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                    return;
                  }
                  vm.isShowWindow = true;
                  vm.aryQuestion = data[0];
                  vm.aryAnswer = data[1];
                  vm.isShowExplain = true;
                  vm.fnLoadQuestionItem();
                  vm.questionMaxNum = vm.aryQuestion.length;
                  break;
              }
              break;
            case "test":
              if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                return;
              }
              vm.isShowWindow = true;
              vm.CourseCalcTypeID = data[0][0].CourseCalcTypeID;
              vm.myTestPaperID = data[0][0].MyTestPaperID;
              vm.aryQuestion = data[1];
              vm.aryAnswer = data[2];
              vm.isShowSubmit = true;
              vm.fnLoadQuestionItem();
              vm.questionMaxNum = vm.aryQuestion.length;
              break;
            case "review":
              if (data[0][0].ReturnValue != undefined) {
                if (vm.fnArrCourseIsNull(data[0][0].ReturnValue) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                  return;
                }
              }
              else {
                if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                  return;
                }
              }
              vm.isShowWindow = true;
              vm.isfirst = data[0][0].isfirst;
              vm.aryQuestion = data[1];
              vm.aryAnswer = data[2];
              vm.isShowExplain = true;
              vm.fnLoadQuestionItem();
              vm.questionMaxNum = vm.aryQuestion.length;
              break;
            case "trial":
              if (vm.fnArrCourseIsNull(data) == 1) {//判断是否请求返回数据集 1 为空 返回  0为非空 程序进行下一步
                return;
              }
              vm.isShowWindow = true;
              vm.aryQuestion = data[0];
              vm.aryAnswer = data[1];
              vm.isShowExplain = true;
              vm.fnLoadQuestionItem();
              vm.questionMaxNum = vm.aryQuestion.length;
              break;
            case "evaluation":
              if (data[1].length == 0) {
                if (data[0].length == 0 && data[0].length == 0 && data[0].length == 0) {
                  loadingService.hide();
                  var alertPopup = $ionicPopup.alert({
                    title: '提示！',
                    template: "本课程暂无测评！敬请期待！"
                  }).then(function () {
                    switch (vm.subType) {
                      case "top":
                        $location.path("tab/listDetail/" + vm.productID + "/" + vm.productName + "/" + vm.subjectID + "/" + vm.subjectName);
                        break;
                      case "down":
                        $location.path("tab/homeDetail/" + vm.productID + "/" + vm.productName);
                        break;
                    }
                  });
                  return
                }
              }
              if (data[1].length < 1 && data[0].length > 0) {// 免费测评题已经做完
                loadingService.hide();
                var alertPopup = $ionicPopup.alert({
                  title: '免费测评题已经做完！',
                  template: "正确率:" + data[0][0].RightRate
                }).then(function () {
                  switch (vm.subType) {
                    case "top":
                      $location.path("tab/listDetail/" + vm.productID + "/" + vm.productName + "/" + vm.subjectID + "/" + vm.subjectName);
                      break;
                    case "down":
                      $location.path("tab/homeDetail/" + vm.productID + "/" + vm.productName);
                      break;
                  }
                });
              }
              else {
                vm.isShowWindow = true;
                vm.aryQuestion = data[1];
                vm.aryAnswer = data[2];
                vm.isShowExplain = true;
                vm.fnLoadQuestionItem();
                vm.questionMaxNum = vm.aryQuestion.length;
              }
              break;
          }
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //load question item
    function fnLoadQuestionItem() {
      vm.cQuestionItem.QuestionID = vm.aryQuestion[vm.currentIndex].QuestionID;
      vm.cQuestionItem.AnswersID = vm.aryQuestion[vm.currentIndex].AnswersID;
      if (vm.aryQuestion[vm.currentIndex].ChoiceID === undefined) {//如果没有choiceID 赋值为""
        vm.cQuestionItem.ChoiceID = "";
      }
      else {
        vm.cQuestionItem.ChoiceID = vm.aryQuestion[vm.currentIndex].ChoiceID;
      }
      vm.cQuestionItem.Topic = vm.aryQuestion[vm.currentIndex].Topic;
      vm.cQuestionItem.QuestionType = vm.aryQuestion[vm.currentIndex].QuestionType;
      vm.cQuestionItem.QuestionMainType = vm.aryQuestion[vm.currentIndex].QuestionMainType;//2016/9/29QuestionMainType用于显示题目类型填空
      vm.cQuestionItem.RecordUrl = vm.aryQuestion[vm.currentIndex].RecordUrl;//名师讲解URL2016/11/14
      //是否隐藏音频2016/11/14
      vm.cQuestionItem.isShowRecord = false;
      if (vm.cQuestionItem.RecordUrl != "" && vm.cQuestionItem.RecordUrl != undefined) {//音频判断是否显示2016/11/14
        vm.cQuestionItem.isShowRecord = true;
      }
      if (vm.isSetLabel) {//如果点击保存标注，将改变的值放入数组
        vm.aryQuestion[vm.currentIndex].isLabel = vm.cQuestionItem.isLabel;
        vm.isSetLabel = false;//将设置标注状态变回false
      }
      vm.cQuestionItem.isLabel = vm.aryQuestion[vm.currentIndex].isLabel;
      if (vm.aryQuestion[vm.currentIndex].AnalyticDesc != undefined) {//如果有AnalyticDesc解析，赋值
        vm.cQuestionItem.AnalyticDesc = vm.aryQuestion[vm.currentIndex].AnalyticDesc;
      }
      vm.cQuestionItem.QuestionTypeID = vm.aryQuestion[vm.currentIndex].QuestionTypeID;
      //vm.cQuestionItem.AnalyticDesc = vm.aryQuestion[vm.currentIndex].AnalyticDesc;
      vm.cQuestionItem.Times = vm.aryQuestion[vm.currentIndex].Times;
      vm.cQuestionItem.PageNumber = vm.aryQuestion[vm.currentIndex].PageNumber;
      vm.cQuestionItem.isShowPageNumber = vm.aryQuestion[vm.currentIndex].isShowPageNumber;//2017/10/10  显示page
      vm.cQuestionItem.BookName = vm.aryQuestion[vm.currentIndex].BookName;
      vm.cQuestionItem.isRight = vm.aryQuestion[vm.currentIndex].IsRight;
      vm.cQuestionItem.ChapterID = vm.aryQuestion[vm.currentIndex].ChapterID;
      vm.cQuestionItem.QuestionTestPoint = vm.aryQuestion[vm.currentIndex].QuestionTestPoint;
      vm.cQuestionItem.QuestionLevel = vm.aryQuestion[vm.currentIndex].QuestionLevel;
      vm.cQuestionItem.RowID = vm.currentIndex + 1;
      if (vm.cQuestionItem.isLabel == 0) {//判断标注
        vm.questionLable = "未标注";
      } else {
        vm.questionLable = "已标注";
      }
      vm.cAnswerItems.splice(0, vm.cAnswerItems.length);
      vm.cQuestionItem.currentTimes = 0;
      vm.cQuestionItem.aryChoiceIDs = [];
      vm.cQuestionItem.aryChoiceNo = [];
      var aryChoiceIDs = vm.cQuestionItem.ChoiceID.split("|").sort();
      var idx = 0;
      for (var i = 0; i < aryChoiceIDs.length; i++) {
        if (aryChoiceIDs[i] != "") {
          vm.cQuestionItem.aryChoiceIDs.push(aryChoiceIDs[i]);
        }
      }
      for (var i = 0; i < vm.aryAnswer.length; i++) {
        if (vm.aryAnswer[i].QuestionID == vm.cQuestionItem.QuestionID) {
          var item = {
            ANo: String.fromCharCode(idx + 65),
            AnswerID: vm.aryAnswer[i].AnswerID,
            AnswerContent: vm.aryAnswer[i].AnswerContent
          };
          vm.cAnswerItems.push(item);
          idx++;
        }
      }
      var AnswersNos = "";
      var ChoiceNos = "";
      idx = 0;
      //正确答案
      for (var i = 0; i < vm.cAnswerItems.length; i++) {
        if (vm.cQuestionItem.AnswersID.indexOf(vm.cAnswerItems[i].AnswerID) >= 0) {
          AnswersNos = AnswersNos + String.fromCharCode(idx + 65) + ",";
        }
        idx++;
      }
      //用户选项
      idx = 0;
      for (var i = 0; i < vm.cAnswerItems.length; i++) {
        for (var j = 0; j < vm.cQuestionItem.aryChoiceIDs.length; j++) {
          if (vm.cAnswerItems[i].AnswerID == vm.cQuestionItem.aryChoiceIDs[j]) {
            ChoiceNos = ChoiceNos + String.fromCharCode(idx + 65) + ",";
          }
        }
        idx++;
      }
      if (ChoiceNos != "") {
        ChoiceNos = ChoiceNos.substring(0, ChoiceNos.length - 1);
      }
      vm.cQuestionItem.ChoiceNos = ChoiceNos;
      if (AnswersNos != "") {
        AnswersNos = AnswersNos.substring(0, AnswersNos.length - 1);
      }
      vm.cQuestionItem.AnswersNos = AnswersNos;
      /**
       * 如果是填空题，用户填写的答案和正确答案
       */
      if (vm.cQuestionItem.QuestionTypeID == 10) {
        vm.cQuestionItem.ChoiceNos = vm.aryQuestion[vm.currentIndex].ChoiceID;
        vm.cQuestionItem.AnswersNos = vm.cQuestionItem.AnswersID;
      }

      if (objtimer != null) {
        $interval.cancel(objtimer);
      }


      /**
       *判断选中状态
       * @type {Array}
       */
      vm.arrSelectPanelIndex = [];
      for (var i = 0; i < vm.aryQuestion.length; i++) {
        var item = {
          "item": (i + 1),
          "choseColorArray": vm.fnChangeQuestionItemColor(vm.aryQuestion[i].isLabel, vm.aryQuestion[i].IsRight, vm.aryQuestion[i].ChoiceID)
        }
        vm.arrSelectPanelIndex.push(item);
      }
      objtimer = $interval(vm.fnQuestionTimes, 1000);
      vm.styleRedTime = {"color": "#020202"};//默认的一个颜色
    }


    //question times
    function fnQuestionTimes() {
      if (vm.cQuestionItem.currentTimes >= 300) {
        vm.styleRedTime = {"color": "#ff0000"};//超过5分变红
        $interval.cancel(objtimer);
        return;
      }
      vm.cQuestionItem.currentTimes++;
    }

    //get choice options
    function fnGetChoice(choiceID, ANos) {
      if (vm.cQuestionItem.QuestionTypeID == 1 || vm.cQuestionItem.QuestionTypeID == 5 || vm.cQuestionItem.QuestionTypeID == 7 || vm.cQuestionItem.QuestionTypeID == 11) {
        var idx = vm.cQuestionItem.aryChoiceIDs.indexOf(choiceID);
        if (idx > -1) {
          vm.cQuestionItem.aryChoiceIDs.splice(idx, 1);
          vm.cQuestionItem.aryChoiceNo.splice(idx, 1);
        }
        else {
          vm.cQuestionItem.aryChoiceIDs.push(choiceID);
          vm.cQuestionItem.aryChoiceNo.push(ANos);
        }
      }
      if (vm.cQuestionItem.QuestionTypeID == 2 || vm.cQuestionItem.QuestionTypeID == 3
        || vm.cQuestionItem.QuestionTypeID == 4 || vm.cQuestionItem.QuestionTypeID == 6 || vm.cQuestionItem.QuestionTypeID == 8
      ) {
        vm.cQuestionItem.aryChoiceIDs.splice(0, vm.cQuestionItem.aryChoiceIDs.length);
        vm.cQuestionItem.aryChoiceIDs.push(choiceID);
        vm.cQuestionItem.aryChoiceNo.splice(0, vm.cQuestionItem.aryChoiceNo.length);
        vm.cQuestionItem.aryChoiceNo.push(ANos);
      }

      var choiceIDs = "";
      for (var i = 0; i < vm.cQuestionItem.aryChoiceIDs.length; i++) {
        if (vm.cQuestionItem.aryChoiceIDs[i] != "") {
          choiceIDs += vm.cQuestionItem.aryChoiceIDs[i] + "|";
        }
      }
      var idx = 0;
      var ChoiceNos = "";
      for (var i = 0; i < vm.cAnswerItems.length; i++) {
        for (var j = 0; j < vm.cQuestionItem.aryChoiceIDs.length; j++) {
          if (vm.cAnswerItems[i].AnswerID == vm.cQuestionItem.aryChoiceIDs[j]) {
            ChoiceNos = ChoiceNos + String.fromCharCode(idx + 65) + ",";
          }
        }
        idx++;
      }
      if (ChoiceNos != "") {
        ChoiceNos = ChoiceNos.substring(0, ChoiceNos.length - 1);
      }
      vm.cQuestionItem.ChoiceNos = ChoiceNos;
      vm.aryQuestion[vm.currentIndex].ChoiceID = choiceIDs;
      vm.cQuestionItem.ChoiceID = choiceIDs;
    }

    //submit question
    function fnQuestionSubmit(isHandle) {
      $interval.cancel(objtimer);
      if (!vm.isFinish) {//2017/10/11
        var isRight = 1;
      } else {
        var isRight = vm.aryQuestion[vm.currentIndex].IsRight;
      }
      //QuestionID,ChapterID,IsRight,ChoiceID,ActualTime,LearningType,ContractID
      var questionID = vm.cQuestionItem.QuestionID;
      var choiceID = vm.aryQuestion[vm.currentIndex].ChoiceID;
      var aryRightAnswer = vm.cQuestionItem.AnswersID.split("|");
      aryRightAnswer.sort();
      vm.cQuestionItem.aryChoiceIDs.sort();

      //2017/9/30  经济师问题出现错误分数
      if (vm.aryQuestion[0].SubjectID == "30565d81-abc8-4192-9a89-247af4c00265") {//经济师科目
        if (vm.moduleType == "exam" || vm.moduleType == "test") {
          if (!vm.isFinish) {
            switch (vm.cQuestionItem.QuestionMainType) {
              case "多选题":
                if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {
                  for (var i = 0; i < aryRightAnswer.length; i++) {
                    if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {
                      isRight = 0;
                      vm.aryQuestion[vm.currentIndex].IsRight = 0;
                      vm.aryQuestion[vm.currentIndex].Score = "0";
                      break;
                    } else {
                      //这里是修改后对的，分数改回2分  2017/10/9
                      vm.aryQuestion[vm.currentIndex].IsRight = 1;
                      vm.aryQuestion[vm.currentIndex].Score = "2";
                    }
                  }
                }
                else if (vm.cQuestionItem.aryChoiceIDs.length < aryRightAnswer.length) {
                  for (var s in vm.cQuestionItem.aryChoiceIDs) {
                    for (var x in aryRightAnswer) {
                      if (aryRightAnswer.indexOf(vm.cQuestionItem.aryChoiceIDs[s]) == -1) {//查找用户数组是否存在于正确数组里
                        //出现不相同的记零分
                        isRight = 0;//这里给isright赋值0
                        vm.aryQuestion[vm.currentIndex].IsRight = 0;
                        vm.aryQuestion[vm.currentIndex].Score = "0";
                        break;
                      } else {
                        if (vm.cQuestionItem.aryChoiceIDs[s] == aryRightAnswer[x]) {//选择的与正确数组作比较
                          arrRight.push(vm.cQuestionItem.aryChoiceIDs[s]);
                        }
                      }
                    }
                  }
                  //加入判断如果有一个错的 就是错的 2017/10/11
                  for (var i = 0; i < vm.cQuestionItem.aryChoiceIDs.length; i++) {
                    for (var j = 0; j < aryRightAnswer.length; j++) {
                      if (aryRightAnswer.indexOf(vm.cQuestionItem.aryChoiceIDs[i]) == -1) {
                        arrRight = [];
                      }
                    }
                  }

                  if (arrRight.length > 0) {//用户选择的正确数集合 全部循环完再加入 2017/9/30
                    isRight = 0.5;//这里赋值半对的 2017/10/25
                    vm.aryQuestion[vm.currentIndex].IsRight = 0.5;// 中级经济师 半对 2017/10/23
                    vm.aryQuestion[vm.currentIndex].Score = (0.5 * arrRight.length ).toString();// 2017/9/30
                    arrRight = [];
                    break;//防止交不了卷 2017/10/24
                  } else {
                    isRight = 0;
                    vm.aryQuestion[vm.currentIndex].IsRight = 0;
                  }

                }
                else { // 长度不同，多选了 错误 2017/9/30
                  isRight = 0;
                  vm.aryQuestion[vm.currentIndex].IsRight = 0;
                  vm.aryQuestion[vm.currentIndex].Score = "0";
                }
                break;
              default:
                if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {//正常计算，如果用户选择数目与正确不一致，错误
                  for (var i = 0; i < aryRightAnswer.length; i++) {
                    if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {//判断选择与正确的是否相等
                      isRight = 0;
                      vm.aryQuestion[vm.currentIndex].IsRight = 0;
                      break;
                    }
                  }
                }
                else {
                  isRight = 0;
                  vm.aryQuestion[vm.currentIndex].IsRight = 0;
                }
                break;
            }
          }
        } else {//经济师的错题问题 2017/8/24
          if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {//正常计算，如果用户选择数目与正确不一致，错误
            for (var i = 0; i < aryRightAnswer.length; i++) {
              if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {//判断选择与正确的是否相等
                isRight = 0;
                vm.aryQuestion[vm.currentIndex].IsRight = 0;
                break;
              }
            }
          }
          else {
            isRight = 0;
            vm.aryQuestion[vm.currentIndex].IsRight = 0;
          }
        }

      }
      else if (vm.aryQuestion[0].SubjectID == "654400fb-7429-4261-be28-8f557aa94911") {//会计
        if (vm.moduleType == "exam" || vm.moduleType == "test") {
          if (vm.cQuestionItem.QuestionMainType == "判断题") {
            if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {//正常计算，如果用户选择数目与正确不一致，错误
              for (var i = 0; i < aryRightAnswer.length; i++) {
                if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {//判断选择与正确的是否相等
                  isRight = 0;
                  IntFalseSum = IntFalseSum - 0.5;
                  break;
                }
                IntTrueSum = IntTrueSum + 1;
              }
            }
            else {
              isRight = 0;
            }
            //判断正确分数和错误分数和是否小于零，小于则等于零，反之为错误分数  后面合计时减去
            if (IntTrueSum + IntFalseSum < 0) {
              itmArray = -IntTrueSum;
            } else {
              itmArray = IntFalseSum;
            }
          }
          else if (vm.cQuestionItem.QuestionMainType == "不定项选择") {
            if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {
              for (var i = 0; i < aryRightAnswer.length; i++) {
                if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {
                  isRight = 0;
                  tempScore = tempScore + 0;
                  break;
                }
              }
            }
            else {
              for (var s in vm.cQuestionItem.aryChoiceIDs) {
                for (var x in aryRightAnswer) {
                  if (aryRightAnswer.indexOf(vm.cQuestionItem.aryChoiceIDs[s]) == -1) {//查找用户数组是否存在于正确数组里
                    //出现不相同的记零分
                    isRight = 0;
                    tempScore += 0;
                    arrRight = [];
                    break;
                  } else {
                    if (vm.cQuestionItem.aryChoiceIDs[s] == aryRightAnswer[x]) {//选择的与正确数组作比较
                      arrRight.push(vm.cQuestionItem.aryChoiceIDs[s]);
                    }
                    if (arrRight.length > 0) {//用户选择的正确数集合
                      tempScore = tempScore + 0.5 * arrRight.length;
                      isRight = 1;
                      return;
                    } else {
                      isRight = 0;
                    }
                  }
                }
              }

            }
          }
          else {
            if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {//正常计算，如果用户选择数目与正确不一致，错误
              for (var i = 0; i < aryRightAnswer.length; i++) {
                if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {//判断选择与正确的是否相等
                  isRight = 0;
                  break;
                }
              }
            }
            else {
              isRight = 0;
            }
          }
        } else { //2017/12/11  会计其他的类型
          if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {//正常计算，如果用户选择数目与正确不一致，错误
            for (var i = 0; i < aryRightAnswer.length; i++) {
              if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {//判断选择与正确的是否相等
                isRight = 0;
                break;
              }
            }
          }
          else {
            isRight = 0;
          }
        }

      }
      else {
        if (aryRightAnswer.length == vm.cQuestionItem.aryChoiceIDs.length) {//正常计算，如果用户选择数目与正确不一致，错误
          for (var i = 0; i < aryRightAnswer.length; i++) {
            if (aryRightAnswer[i] != vm.cQuestionItem.aryChoiceIDs[i]) {//判断选择与正确的是否相等
              isRight = 0;
              break;
            }
          }
        }
        else {
          isRight = 0;
        }
      }

      /**
       * 判断如果是填空则判断答案与用户选择是否相同
       */
      if (vm.cQuestionItem.QuestionTypeID == 10) {
        if (vm.cQuestionItem.AnswersNos == vm.aryQuestion[vm.currentIndex].ChoiceID) {//用户所选和正确答案比较
          isRight = 1;
        } else {
          isRight = 0;
        }
      }

      if (vm.cQuestionItem.QuestionTypeID == 9) {
        isRight = 1;
      }
      var learningType = "1";
      vm.aryQuestion[vm.currentIndex].IsRight = isRight;

      var actualTime = vm.cQuestionItem.currentTimes;
      if (actualTime >= 300) {
        actualTime = 300;
      }
      learingingBoardService.questionID = questionID;
      learingingBoardService.chapterID = vm.cQuestionItem.ChapterID;
      learingingBoardService.isRight = isRight;
      if (choiceID == undefined) {
        learingingBoardService.choiceID = "";
      } else {
        learingingBoardService.choiceID = choiceID;
      }
      learingingBoardService.actualTime = actualTime;
      learingingBoardService.learningType = learningType;
      learingingBoardService.contractID = vm.contractID;
      learingingBoardService.myExamPaperID = vm.myExamPaperID;
      learingingBoardService.myTestPaperID = vm.myTestPaperID;
      learingingBoardService.freeTestID = vm.aryQuestion[vm.currentIndex].FreeTestID;
      learingingBoardService.evaluationID = vm.aryQuestion[vm.currentIndex].EvaluationID;
      learingingBoardService.learningRecordID = vm.aryQuestion[vm.currentIndex].LearningRecordID;
      learingingBoardService.section = vm.aryQuestion[vm.currentIndex].Section;
      learingingBoardService.isfirst = vm.isfirst;
      if (isHandle == undefined) {
        isHandle = 0;
      }
      learingingBoardService.isHandle = isHandle;//未交卷给0
      learingingBoardService.examPaperID = vm.examPaperID;
      learingingBoardService.fnSaveQuestion()
        .then(function (data) {
          //ignore
          if (isHandle) {
            vm.isFinish = 1;
            var intRightCount = 0;
            var intScore = 0;
            var contM = 0;//中级经济师半对的算成错的样式 2017/10/25
            for (var i = 0; i < vm.aryQuestion.length; i++) {
              if (vm.aryQuestion[i].IsRight == 1 || vm.aryQuestion[i].IsRight == 0.5) {// 中级经济师 半对 2017/10/23
                intRightCount++;
                intScore = intScore + parseFloat(vm.aryQuestion[i].Score);
              }
              if (vm.aryQuestion[i].IsRight == 0.5) {
                contM++;//中级经济师半对的算成错的样式 2017/10/25
              }
            }
            vm.isShowExplain = true;
            vm.isShowSubmit = false;
            vm.arrSelectPanelIndex = [];
            for (var i = 0; i < vm.aryQuestion.length; i++) {
              var item = {
                "item": (i + 1),
                "choseColorArray": vm.fnChangeQuestionItemColor(vm.aryQuestion[i].isLabel, vm.aryQuestion[i].IsRight, vm.aryQuestion[i].ChoiceID)
              };
              vm.arrSelectPanelIndex.push(item);
            }
            switch (vm.moduleType) {
              case "evaluation":
                var alertPopup = $ionicPopup.alert({
                  title: '免费测评题！',
                  template: "正确率:" + (intRightCount / vm.aryQuestion.length).toFixed(2)
                });
                break;
              default:
                //分类为计分输出  经济师科目    会计
                if (vm.aryQuestion[0].SubjectID == "30565d81-abc8-4192-9a89-247af4c00265" || vm.aryQuestion[0].SubjectID == "654400fb-7429-4261-be28-8f557aa94911") {
                  //如果是会计中的判断题
                  if (vm.aryQuestion[0].SubjectID == "654400fb-7429-4261-be28-8f557aa94911") {
                    var alertPopup = $ionicPopup.alert({
                      title: '考试题',
                      template: "您一共做对了：" + intRightCount + "题,共记：" + (intScore + itmArray + tempScore) + "分"//这里总和是判断加其他分数  判断的分数是错误需要减去的分数 tempScore 为不定项
                    });
                  } else if (vm.aryQuestion[0].SubjectID == "30565d81-abc8-4192-9a89-247af4c00265") {//经济师
                    var alertPopup = $ionicPopup.alert({
                      title: '考试题',
                      template: "您一共做对了：" + (intRightCount - contM) + "题,共记：" + intScore + "分"//这里总和是多选选择单个选项加其他分数  去掉经济师加分 改为一起总和 2017/9/30
                    });
                  }
                  else {
                    var alertPopup = $ionicPopup.alert({
                      title: '考试题',
                      template: "您一共做对了：" + intRightCount + "题,共记：" + intScore + "分"
                    });
                  }
                } else {
                  var alertPopup = $ionicPopup.alert({
                    title: '考试题',
                    template: "您一共做对了：" + intRightCount + "题,共记：" + intScore + "分"
                  });
                }
            }

          }
          else {
            //loadingService.hide();
          }
        }, function (error) {
          vm.isNextReturn = false;
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //set or get label setting
    function fnSetLabel() {
      learingingBoardService.questionID = vm.cQuestionItem.QuestionID;
      learingingBoardService.examPaperID = vm.examPaperID;
      learingingBoardService.fnSetLabel()
        .then(function (data) {
          if (data == "") {
            vm.cQuestionItem.isLabel = vm.cQuestionItem.isLabel == 0 ? 1 : 0;
            //fnLoadQuestion();
            vm.isSetLabel = true;
            //2017/10/9  标注后重新修改样式变化，不进行刷新页面
            if (vm.isSetLabel) {//如果点击保存标注，将改变的值放入数组
              vm.aryQuestion[vm.currentIndex].isLabel = vm.cQuestionItem.isLabel;
              vm.isSetLabel = false;//将设置标注状态变回false
            }
            if (vm.cQuestionItem.isLabel == 0) {//判断标注
              vm.questionLable = "未标注";
            } else {
              vm.questionLable = "已标注";
            }
            //fnLoadQuestionItem();
          }
        }), function (error) {
        $cordovaToast.showShortBottom('数据保存异常！');
      }
    }

    vm.fnLoadQuestion();
  }


})()
