/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myTestController", myTestController);

  function myTestController($state, $ionicPopup, $location, $stateParams, $cordovaToast, loadingService, myTestService, accountService) {
    var myTest = this;
    myTest.fnSimulationListGet = fnSimulationListGet;//定义方法
    myTest.fnGoList = fnGoList;
    myTest.testList = [];//创建新的数组用来接收数据并展示
    myTest.customerID = accountService.fnGetUser().CustomerID;//获取customerID
    function fnGoList() {
      $state.go('tab.person');
      //$location.path("tab/person");
    }

    myTest.isShowImgNull = false;
    /**
     * 请求我的模拟题列表
     */
    function fnSimulationListGet() {
      loadingService.show();
      myTestService.FunSimulationListGet(myTest.customerID)
        .then(function (data) {
          if (data[0].length <= 0) {
            myTest.isShowImgNull = true;
            //var alertPopup = $ionicPopup.alert({
            //  title: '提示',
            //  template: '暂无模拟题！'
            //});
            //alertPopup.then(function (res) {
            //  $location.path("/tab/person");
            //});
            loadingService.hide();
            return;
          }
          for (var i = 0; i < data[0].length; i++) {
            var item = {
              "ContractID": data[0][i].ContractID,
              "CourseID": data[0][i].CourseID,
              "CourseName": data[0][i].CourseName,
              "CustomerID": data[0][i].CustomerID,
              "isClosed": data[0][i].isClosed,
              "isFreezed": data[0][i].isFreezed,
              "Termination": data[0][i].Termination,
            }
            myTest.testList.push(item);
          }
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //启动方法
    fnSimulationListGet()

  }
})()
