/**
 * Created by zjw-pc on 2016/5/21.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myVideoDownloadController", myVideoDownloadController);

  function myVideoDownloadController($state,$ionicPopup,$location, $cordovaToast, loadingService, myVideoService, accountService) {
    var myVideoDownload = this;
    myVideoDownload.fnVideoListGet = fnVideoListGet;//定义方法
    myVideoDownload.fnGoList = fnGoList;//定义方法
    myVideoDownload.VideoCourseList = new Array();//创建新的数组用来接收数据并展示
    myVideoDownload.customerID = accountService.fnGetUser().CustomerID;//获取customerID
    function fnGoList() {
      $state.go('tab.person');
      //$location.path("tab/person");
    }

    /**
     * 请求我的视频列表
     */
    function fnVideoListGet() {
      loadingService.show();
      myVideoService.FunVideoListGet(myVideoDownload.customerID)
        .then(function (data) {
          if (data[0].length <= 0) {
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '暂无视频！'
            });
            alertPopup.then(function (res) {
              $location.path("/tab/person");
            });
            loadingService.hide();
            return;
          }
          //console.log(data[0])
          myVideoDownload.VideoCourseList = data[0];
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    //启动方法
    fnVideoListGet()

  }
})()
