/**
 * Created by zjw-pc on 2017/10/31.
 */
(function () {
    //'use strict';
    angular.module("myApp")
        .controller("broadcastController", broadcastController);

    function broadcastController($sce, liveBroadcastService, $stateParams, $scope, $ionicHistory, $state, $cordovaToast, loadingService, $ionicPopover, _customerType, _version) {
        var broadcast = this;
        broadcast.fnBack = fnBack;
        function fnBack() {
            $ionicHistory.goBack();
        }

        broadcast.ProductID = $stateParams.ProductID;//获取直播ProductID
        broadcast.fnGetLiveUrl = fnGetLiveUrl;
        function fnGetLiveUrl() {
            loadingService.show();
            liveBroadcastService.funGetLiveUrl(broadcast.ProductID)
                .then(function (data) {
                        var str = data;
                        str = str.replace(/https/, "http");//转成http格式
                        $scope.httpsUrl = $sce.trustAsResourceUrl(str);
                        loadingService.hide();
                    }, function (error) {
                        $cordovaToast.showShortBottom('网络出现异常！');
                    }
                );
        }

        fnGetLiveUrl();
    }
})();
