/**
 * Created by zjw-pc on 2017/10/30.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("liveBroadcastCalendarController", liveBroadcastCalendarController);

  function liveBroadcastCalendarController($ionicPopup, $stateParams, accountService, liveBroadcastService, $ionicHistory, $scope, $location, $state, loadingService, $ionicPopover) {
    var liveBroadcastCalendar = this;
    liveBroadcastCalendar.fnBack = fnBack;
    function fnBack() {
      $ionicHistory.goBack();
    }

    liveBroadcastCalendar.fnStartInfo = fnStartInfo;//进入详情页
    function fnStartInfo(datasID, datasName) {
      $location.path('tab/liveBroadcastInfo/' + datasID + "/" + datasName);
    }

    /**
     * 打开subject的弹窗方法
     * @type {popoverSubjectShow}
     */
    liveBroadcastCalendar.popoverSubjectShow = popoverSubjectShow;
    liveBroadcastCalendar.popoverSubjectClose = popoverSubjectClose;
    $ionicPopover.fromTemplateUrl('subject-pop.html', {
      scope: $scope
    }).then(function (popover) {
      liveBroadcastCalendar.popover1 = popover;
    });
    function popoverSubjectShow($event) {
      liveBroadcastCalendar.popover1.show($event);
    }

    $scope.$on('popover.hidden', function () {
      // 执行代码
    });
    function popoverSubjectClose($event) {
      liveBroadcastCalendar.popover1.hide();
    }

    liveBroadcastCalendar.lists = [
      {
        "SubjectID": "",
        "SubjectName": "全部课程",
        "SubjectColor": "#ff0000" //默认全部 红色
      },
      {
        "SubjectID": "a0b27d37-0559-4695-b948-1e031adb82fc",
        "SubjectName": "基金",
        "SubjectColor": "#7a9fbc"
      },
      {
        "SubjectID": "30565d81-abc8-4192-9a89-247af4c00265",
        "SubjectName": "经济师",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "6f56ba18-7a89-40cd-9304-27a159388ad1",
        "SubjectName": "期货",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "4bad7c0d-a00f-46db-b09b-4691dce553fe",
        "SubjectName": "银行",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "a6c2d781-2187-426f-9399-5cf3fc9340a6",
        "SubjectName": "CFA",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "6d376160-e3ed-42aa-ae39-89065554735d",
        "SubjectName": "证券",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "654400fb-7429-4261-be28-8f557aa94911",
        "SubjectName": "会计",
        "SubjectColor": "#7a9fbc"
      }, {
        "SubjectID": "7feff67b-9947-464a-a901-e8e96635afe9",
        "SubjectName": "CPA",
        "SubjectColor": "#7a9fbc"
      }

    ];//课程数组
    liveBroadcastCalendar.allSubject = $stateParams.typeName; // 初始化条件 typeName 为获取传过来的 2017/11/15

    //liveBroadcastCalendar.idxType = $stateParams.idxType;//直播和回放的状态 2017/11/22
    liveBroadcastCalendar.allSubjectId = fnSubjectID();//日历与list的不同处 需要加ID进行筛选
    function fnSubjectID() {
      for (var i = 0; i < liveBroadcastCalendar.lists.length; i++) {
        if (liveBroadcastCalendar.allSubject === liveBroadcastCalendar.lists[i].SubjectName) {
          liveBroadcastCalendar.allSubjectId = liveBroadcastCalendar.lists[i].SubjectID;
          liveBroadcastCalendar.lists[i].SubjectColor = "#ff0000";// 2017/12/12 添加修改进入日历页面的样式
        }
        else {// 2017/12/12 添加修改进入日历页面的样式
          liveBroadcastCalendar.lists[i].SubjectColor = "#7a9fbc";
        }
      }
      return liveBroadcastCalendar.allSubjectId;
    }


    liveBroadcastCalendar.calendar = "日历显示";
    //日历颜色画入item
    liveBroadcastCalendar.drawItemList = [];

    var dates = new Date();
    liveBroadcastCalendar.calendarDay = getNowFormatDate(dates);
    liveBroadcastCalendar.calendarM = getNowFormatDateSecond(dates);
    //声明时间 获取当天时间
    var Year = 0;
    var Month = 0;
    var Day = 0;
    Year = dates.getFullYear();
    Month = dates.getMonth();
    Day = dates.getDate();
    liveBroadcastCalendar.onclickCalendar = onclickCalendar;//日历显示隐藏方法
    liveBroadcastCalendar.shows = true;//控制显示隐藏
    liveBroadcastCalendar.calendar = "列表显示";

    //显示隐藏方法
    function onclickCalendar() {
      liveBroadcastCalendar.shows = !liveBroadcastCalendar.shows;//改变显隐状态

      if (liveBroadcastCalendar.calendar == "日历显示") {
        liveBroadcastCalendar.calendar = "列表显示";

      } else {
        liveBroadcastCalendar.calendar = "日历显示";
        fnBack();
      }

    }

    /**
     * 时间格式化
     * @param day
     * @returns {string}
     */
    function getNowFormatDate(day) {
      var Year = 0;
      var Month = 0;
      var Day = 0;
      var CurrentDate = "";
      Year = day.getFullYear();//ie火狐下都可以
      Month = day.getMonth() + 1;
      Day = day.getDate();
      CurrentDate += Year + "/";
      if (Month >= 10) {
        CurrentDate += Month + "/";
      }
      else {
        CurrentDate += "0" + Month + "/";
      }
      if (Day >= 10) {
        CurrentDate += Day;
      }
      else {
        CurrentDate += "0" + Day;
      }
      return CurrentDate;
    }

    //时间不加日的 只有年月
    function getNowFormatDateSecond(day) {
      var Year = 0;
      var Month = 0;
      var Day = 0;
      var CurrentDate = "";
      Year = day.getFullYear();//ie火狐下都可以
      Month = day.getMonth() + 1;
      Day = day.getDate();
      CurrentDate += Year + "年";
      if (Month >= 10) {
        CurrentDate += Month + "月";
      }
      else {
        CurrentDate += "0" + Month + "月";
      }
      //if (Day >= 10) {
      //  CurrentDate += Day;
      //}
      //else {
      //  CurrentDate += "0" + Day;
      //}
      return CurrentDate;
    }

    liveBroadcastCalendar.onClickListener = onClickListener;//全部课程的点击方法
    function onClickListener(inx) {
      //循环赋值颜色
      for (var i in liveBroadcastCalendar.lists) {
        if (i == inx) {
          liveBroadcastCalendar.lists[i].SubjectColor = "#ff0000";
        } else {
          liveBroadcastCalendar.lists[i].SubjectColor = "#7a9fbc";
        }
      }
      liveBroadcastCalendar.allSubjectId = liveBroadcastCalendar.lists[inx].SubjectID;//筛选的
      liveBroadcastCalendar.allSubject = liveBroadcastCalendar.lists[inx].SubjectName;
      liveBroadcastCalendar.fnLiveView("TimeSearch", liveBroadcastCalendar.lists[inx].SubjectID, liveBroadcastCalendar.calendarM + "1日", selectMonthToDay(liveBroadcastCalendar.calendarM));
      popoverSubjectClose();
    }

    //liveBroadcastCalendar.btnOnClickListener = btnOnClickListener;//footbar 点击事件
    //liveBroadcastCalendar.isShowBtn = true;
    //liveBroadcastCalendar.btnBarColor1 = "#F9FF00";
    //liveBroadcastCalendar.btnBarColor2 = "#ffffff";
    //function btnOnClickListener(index) {
    //  //判断课程是否有 2017/11/8
    //  if (liveBroadcastCalendar.btn2List.length <= 0 && liveBroadcastCalendar.isShowBtn) {
    //    var alertPopup = $ionicPopup.alert({
    //      title: '提示',
    //      template: '当前科目无回放！'
    //    });
    //  }
    //  if (liveBroadcastCalendar.btn1List.length <= 0 && !liveBroadcastCalendar.isShowBtn) {
    //    var alertPopup = $ionicPopup.alert({
    //      title: '提示',
    //      template: '当前科目无直播！'
    //    });
    //  }
    //  switch (index) {
    //    case 1:
    //      liveBroadcastCalendar.btnBarColor1 = "#F9FF00";
    //      liveBroadcastCalendar.btnBarColor2 = "#ffffff";
    //      liveBroadcastCalendar.isShowBtn = true;
    //      break;
    //    case 2:
    //      liveBroadcastCalendar.btnBarColor1 = "#ffffff";
    //      liveBroadcastCalendar.btnBarColor2 = "#F9FF00";
    //      liveBroadcastCalendar.isShowBtn = false;
    //      break;
    //  }
    //}

    $scope.onSwipeUp = function () {
      $('section').hide();//日历隐藏
      console.log("onSwipeUp")
    };
    $scope.onSwipeDown = function () {
      $('section').show();//日历显示
      console.log("onSwipeDown")
    };
    /**
     * 直播列表显示
     * @param SearchType
     * @param subjectid
     * @param StartDate
     * @param EndDate
     */
    liveBroadcastCalendar.dataUrl = "http://www.lekaowang.cn";
    liveBroadcastCalendar.lvBrList = [];
    liveBroadcastCalendar.btn1List = [];
    liveBroadcastCalendar.btn2List = [];
    liveBroadcastCalendar.fnLiveView = fnLiveView;
    function fnLiveView(SearchType, subjectid, StartDate, EndDate) {
      loadingService.show();
      liveBroadcastService.funLiveView(SearchType, "", subjectid, StartDate, EndDate)
        .then(function (data) {
            liveBroadcastCalendar.lvBrList = [];
            liveBroadcastCalendar.btn1List = [];
            liveBroadcastCalendar.btn2List = [];
            liveBroadcastCalendar.isShowList = false;
            if (data.length <= 0) {
              liveBroadcastCalendar.isShowList = true;
            } else {
              liveBroadcastCalendar.lvBrList = data[0];
              buttonClass(data[0]);

              //判断课程是否有 2017/11/8
              if (liveBroadcastCalendar.lvBrList.length <= 0 && !liveBroadcastCalendar.isShowBtn) {
                var alertPopup = $ionicPopup.alert({
                  title: '提示',
                  template: '当前无直播和回放！'
                });
              }

              //for (var i = 0; i < liveBroadcastCalendar.lvBrList.length; i++) {
              //  if (liveBroadcastCalendar.lvBrList[i].btnName == "进入回放") {
              //    liveBroadcastCalendar.btn2List.push(liveBroadcastCalendar.lvBrList[i]);
              //  } else {
              //    liveBroadcastCalendar.btn1List.push(liveBroadcastCalendar.lvBrList[i]);
              //  }
              //}
              ////判断课程是否有 2017/11/8
              //if (liveBroadcastCalendar.btn2List.length <= 0 && !liveBroadcastCalendar.isShowBtn) {
              //  var alertPopup = $ionicPopup.alert({
              //    title: '提示',
              //    template: '当前科目无回放！'
              //  });
              //}
              //if (liveBroadcastCalendar.btn1List.length <= 0 && liveBroadcastCalendar.isShowBtn) {
              //  var alertPopup = $ionicPopup.alert({
              //    title: '提示',
              //    template: '当前科目无直播！'
              //  });
              //}
            }
            loadingService.hide();
          }, function (error) {
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '网络出现异常！'
            });
          }
        );
    }

    /**
     *初始化数据列表 区分查询列表，方便生成日历样式
     * @param SearchType
     * @param subjectid
     * @param StartDate
     * @param EndDate
     */
    function fnLiveViews(SearchType, subjectid, StartDate, EndDate) {
      loadingService.show();
      liveBroadcastService.funLiveView(SearchType, "", subjectid, StartDate, EndDate)
        .then(function (data) {
            liveBroadcastCalendar.lvBrList = [];
            liveBroadcastCalendar.isShowList = false;
            if (data.length <= 0) {
              liveBroadcastCalendar.isShowList = true;
            } else {
              liveBroadcastCalendar.lvBrList = data[0];
              buttonClass(data[0]);
              for (var j = 0; j < liveBroadcastCalendar.lvBrList.length; j++) {
                if (liveBroadcastCalendar.lvBrList[j].btnName == "进入回放") {
                  liveBroadcastCalendar.btn2List.push(liveBroadcastCalendar.lvBrList[j]);
                } else {
                  liveBroadcastCalendar.btn1List.push(liveBroadcastCalendar.lvBrList[j]);
                }
              }

              for (var i = 0; i < liveBroadcastCalendar.lvBrList.length; i++) {
                if (liveBroadcastCalendar.lvBrList[i].btnName == "进入回放") {
                  var item = {
                    'dt': data[0][i].StartDate.split(' ').slice(0, 1)[0],
                    "bgcolor": "#cccccc",
                    "color": "#ffffff"
                  };
                } else if (liveBroadcastCalendar.lvBrList[i].StartDate.split(' ').slice(0, 1)[0] == liveBroadcastCalendar.calendarDay) {
                  var item = {
                    'dt': data[0][i].StartDate.split(' ').slice(0, 1)[0],
                    "bgcolor": "#ff9900",
                    "color": "#ffffff"
                  };
                } else {
                  var item = {
                    'dt': data[0][i].StartDate.split(' ').slice(0, 1)[0],
                    "bgcolor": "#66cccc",
                    "color": "#ffffff"
                  };
                }

                liveBroadcastCalendar.drawItemList.push(item);//日历样式的设置数组
              }
              var settings = {
                defaultDate: {
                  day: Day,    // 1 through 31
                  month: Month,  // 0 through 11
                  year: Year // No limits
                },
                formats: {
                  display: {
                    day: '%D',
                    month: '%Month',
                    year: '%Y',
                    date: '%Y年 %Month %D日'
                  },
                  data: {
                    day: '%D',
                    month: '%M',
                    year: '%Y',
                    date: '%Y-%M-%D'
                  }
                },
                openByDefault: true,
                drawItems: liveBroadcastCalendar.drawItemList,
                monthcallback: funCall
              };//日历设置列表

              function funCall(curd) {
                liveBroadcastCalendar.calendarM = curd.year + "年" + (curd.month + 1) + "月";
                liveBroadcastCalendar.fnLiveView("TimeSearch", "", liveBroadcastCalendar.calendarM + "1日", selectMonthToDay(liveBroadcastCalendar.calendarM));
              }

              //生成日历 调用rendezvous.js
              $('#rendez-vous-open')
                .on('rendezvous-change', function (event, rdv) {
                  console.log('rdv-change');
                  //为顶端日期赋值
                  $(".rendezvous-datepicker-navigation-action.rendezvous-datepicker-navigation-up").text(rdv.format("%Y年%M月", rdv.getDate()));
                  //console.log( rdv.format("%Y-%M-%D",rdv.getDate()));
                  liveBroadcastCalendar.calendarDay = rdv.format("%Y年%M月%D日", rdv.getDate());

                  liveBroadcastCalendar.fnLiveView("TimeSearch", liveBroadcastCalendar.allSubjectId, liveBroadcastCalendar.calendarDay, liveBroadcastCalendar.calendarDay);
                  //liveBroadcastCalendar.shows = false;//隐藏显示 ng-show = false
                  liveBroadcastCalendar.calendarM = rdv.format("%Y年%M月", rdv.getDate());
                })
                .RendezVous(settings);

              $(".rendezvous-datepicker-navigation-action.rendezvous-datepicker-navigation-up").click(function () {
                $('section').show();
              });


            }
            //修改查詢 按月份 2017/12/6
            liveBroadcastCalendar.fnLiveView("TimeSearch", liveBroadcastCalendar.allSubjectId, liveBroadcastCalendar.calendarM + "1日", selectMonthToDay(liveBroadcastCalendar.calendarM));//初始化载入的是当前typeName的查询 2017/11/15
            //btnOnClickListener(parseInt(liveBroadcastCalendar.idxType));//直播和回放的状态 2017/11/22
            loadingService.hide();
          }, function (error) {
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '网络出现异常！'
            });
          }
        );
    }

    /**
     * 选择的当前月有多少天
     * @param mess
     * @returns {number}
     */
    function selectMonthToDay(mess, isNext) {
      var year = parseInt((mess.split('年')[0]));
      var month = parseInt((mess.split('年')[1]).split('月')[0]);
      var days = 0;
      if (month < 1 || month > 12) {
      } else if (month == 2) {
        if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0) {
          days = 29;
        } else {
          days = 28;
        }
      } else {
        if ((month == 4) || (month == 6) || (month == 9) || (month == 11)) {
          days = 30;
        } else {
          days = 31;
        }
      }
      return mess + days + "日";
    }

    /**
     * 初始化列表方法
     */
    fnLiveViews("subject", "", "", "");


    //liveBroadcastCalendar.btnName = "立即报名";
    function buttonClass(data) {
      for (var i = 0; i < data.length; i++) {
        if (accountService.fnGetUser().CustomerID == undefined) {
          if (data[i].status == "2") {
            data[i].btnName = "进入回放";
          } else if (data[i].status == "3") {
            data[i].btnName = "进入直播";
          } else {
            if (parseInt(data[i].LiveMaxPersonCount) - parseInt(data[i].doLiveQty) > 0) {
              data[i].btnName = "立即报名";
            } else {
              data[i].btnName = "报名已满";
            }
          }
        }
        else {
          if (data[i].status == "1") {
            if (parseInt(data[i].IQty) > 0) {
              data[i].btnName = "已经报名";
            } else if (parseInt(data[i].LiveMaxPersonCount) - parseInt(data[i].doLiveQty) > 0) {
              data[i].btnName = "立即报名";
            } else {
              data[i].btnName = "报名已满";
            }
          } else if (data[i].status == "3") {
            data[i].btnName = "进入直播";
          } else {
            data[i].btnName = "进入回放";
          }
        }
      }
    }

  }
})();
