/**
 * Created by zjw-pc on 2017/10/30.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("myLiveBroadcastController", myLiveBroadcastController);

  function myLiveBroadcastController($location, liveBroadcastService, $scope, $ionicPopup, $state, $cordovaToast, loadingService, $ionicPopover, _customerType, _version) {
    var myLiveBroadcast = this;
    myLiveBroadcast.fnBack = fnBack;
    function fnBack() {
      $state.go("tab.person");
    }

    myLiveBroadcast.popType = "全部";//类型
    myLiveBroadcast.popState = "全部";//状态

    //  index 代表数组位置 isFree 代表是否免费 0 免费 1 付费 isLive 代表直播状态 0 未开始 1直播中 2是已结束
    myLiveBroadcast.popTypeList = [
      {
        "name": "全部",
        "index": 0,
        "isFree": "",
        "itemColor": "#0a9dc7" //默认全部
      },
      {
        "name": "免费",
        "index": 1,
        "isFree": 0,
        "itemColor": "#000000"
      },
      {
        "name": "付费",
        "index": 2,
        "isFree": 1,
        "itemColor": "#000000"
      }];
    myLiveBroadcast.popStateList = [
      {
        "name": "全部",
        "index": 0,
        "isLive": "",
        "itemColor": "#0a9dc7" //默认全部
      },
      {
        "name": "直播中",
        "index": 1,
        "isLive": 1,
        "itemColor": "#000000"
      },
      {
        "name": "未开始",
        "index": 2,
        "isLive": 0,
        "itemColor": "#000000"
      }, {
        "name": "已结束",
        "index": 3,
        "isLive": 2,
        "itemColor": "#000000"
      }];

    myLiveBroadcast.fnPopOpenL = fnPopOpenL;//弹出框 类型
    function fnPopOpenL() {
      myLiveBroadcast.myPopupType = $ionicPopup.show({
        template: '<list class="popStyle" ng-repeat="item in myLiveBroadcast.popTypeList">' +
        '<ion-item class="item" align="center" style="color: {{item.itemColor}}"' +
        ' ng-click="myLiveBroadcast.TypeItemClick(item.name,item.index,item.isFree)">{{item.name}}</ion-item>' +
        '</list>',
        title: '<b>选择状态</b>',
        scope: $scope,
        buttons: [
          {
            text: '取消',
            type: "button-cancel"
          }

        ]
      });
    }

    myLiveBroadcast.popTypeInx = "";//初始化类型 全部
    myLiveBroadcast.popStateInx = "";//初始化状态 全部


    myLiveBroadcast.TypeItemClick = TypeItemClick; //type 类型单击事件
    function TypeItemClick(type, index, isFree) {
      myLiveBroadcast.popType = type;
      myLiveBroadcast.popTypeInx = isFree;//类型的选择值
      //alert("myLiveBroadcast.popStateInx-->" + myLiveBroadcast.popStateInx + "*****" + "myLiveBroadcast.popTypeInx-->" + myLiveBroadcast.popTypeInx)
      for (var i in myLiveBroadcast.popTypeList) {
        if (i == index) {
          myLiveBroadcast.popTypeList[i].itemColor = "#0a9dc7";
        } else {
          myLiveBroadcast.popTypeList[i].itemColor = "#000000";
        }
      }
      switch (index) {
        case 0://全部 SubjectID, isFree, isLive, isLoa
          fnPerson_LiveList("", "", myLiveBroadcast.popStateInx, 1);
          break;
        case 1://免费 SubjectID, isFree, isLive, isLoa
          fnPerson_LiveList("", 0, myLiveBroadcast.popStateInx, 1);
          break;
        case 2://付费 SubjectID, isFree, isLive, isLoa
          fnPerson_LiveList("", 1, myLiveBroadcast.popStateInx, 1);
          break;
      }
      myLiveBroadcast.myPopupType.close();
    }


    myLiveBroadcast.fnPopOpenZ = fnPopOpenZ;//弹出框状态
    function fnPopOpenZ() {
      myLiveBroadcast.myPopupState = $ionicPopup.show({
        template: '<list class="popStyle" ng-repeat="item in myLiveBroadcast.popStateList">' +
        '<ion-item class="item" align="center" style="color: {{item.itemColor}}" ' +
        ' ng-click="myLiveBroadcast.StateItemClick(item.name,item.index,item.isLive)">{{item.name}}</ion-item>' +
        '</list>',
        title: '<b>选择状态</b>',
        scope: $scope,
        buttons: [
          {
            text: '取消',
            type: "button-cancel"
          }

        ]
      });
    }

    myLiveBroadcast.StateItemClick = StateItemClick; //state 状态单击事件
    function StateItemClick(type, index, isLive) {
      myLiveBroadcast.popState = type;
      myLiveBroadcast.popStateInx = isLive;//状态的选择值
      //alert("myLiveBroadcast.popStateInx-->" + myLiveBroadcast.popStateInx + "*****" + "myLiveBroadcast.popTypeInx-->" + myLiveBroadcast.popTypeInx)
      for (var i in myLiveBroadcast.popStateList) {
        if (i == index) {
          myLiveBroadcast.popStateList[i].itemColor = "#0a9dc7";
        } else {
          myLiveBroadcast.popStateList[i].itemColor = "#000000";
        }
      }
      switch (index) {
        case 0://全部 SubjectID, isFree, isLive, isLoa
          fnPerson_LiveList("", myLiveBroadcast.popTypeInx, "", 1);
          break;
        case 1://直播中 SubjectID, isFree, isLive, isLoa
          fnPerson_LiveList("", myLiveBroadcast.popTypeInx, 1, 1);
          break;
        case 2://未开始 SubjectID, isFree, isLive, isLoa
          fnPerson_LiveList("", myLiveBroadcast.popTypeInx, 0, 1);
          break;
        case 3://已结束 SubjectID, isFree, isLive, isLoa
          fnPerson_LiveList("", myLiveBroadcast.popTypeInx, 2, 1);
          break;
      }

      myLiveBroadcast.myPopupState.close();
    }

    myLiveBroadcast.myLiveList = [];
    myLiveBroadcast.fnPerson_LiveList = fnPerson_LiveList;//列表方法
    function fnPerson_LiveList(SubjectID, isFree, isLive, isLoad) {
      loadingService.show();
      liveBroadcastService.funPerson_LiveList(SubjectID, isFree, isLive, isLoad)
        .then(function (data) {
            myLiveBroadcast.myLiveList = [];
            myLiveBroadcast.myLiveList = data[0];
            if (data.length <= 0) {
              loadingService.hide();
              return
            } else {
              for (var i = 0; i < myLiveBroadcast.myLiveList.length; i++) {
                if (myLiveBroadcast.myLiveList[i].LiveState == "1") {
                  myLiveBroadcast.myLiveList[i].LiveState = "未开始";
                  myLiveBroadcast.myLiveList[i].buttonText = "已经报名";
                  myLiveBroadcast.myLiveList[i].buttonColor = "#ff9900";
                } else if (myLiveBroadcast.myLiveList[i].LiveState == "2") {
                  myLiveBroadcast.myLiveList[i].LiveState = "直播中";
                  myLiveBroadcast.myLiveList[i].buttonText = "进入直播";
                  myLiveBroadcast.myLiveList[i].buttonColor = "#0a9dc7";
                } else if (myLiveBroadcast.myLiveList[i].LiveState == "3") {
                  myLiveBroadcast.myLiveList[i].LiveState = "已结束";
                  myLiveBroadcast.myLiveList[i].buttonText = "进入回放";
                  myLiveBroadcast.myLiveList[i].buttonColor = "#0a9dc7";
                }

                if (parseInt(myLiveBroadcast.myLiveList[i].FinalAmount) > 0) {
                  myLiveBroadcast.myLiveList[i].showFree = "付费";
                } else {
                  myLiveBroadcast.myLiveList[i].showFree = "免费";
                }
              }
            }
            loadingService.hide();
          }, function (error) {
            $cordovaToast.showShortBottom('网络出现异常！');
          }
        );
    }

    fnPerson_LiveList("", "", "", 0);
    myLiveBroadcast.fnStartInfo = fnStartInfo;//进入详情页
    function fnStartInfo(datasID, datasName) {
      $location.path('tab/liveBroadcastInfo/' + datasID + "/" + datasName);
    }

    myLiveBroadcast.loadNewerStories = loadNewerStories;//刷新
    function loadNewerStories() {
      myLiveBroadcast.myLiveList = [];
      myLiveBroadcast.popType = "全部";//类型 2017/12/5 修改初始状态
      myLiveBroadcast.popState = "全部";//状态 2017/12/5 修改初始状态
      myLiveBroadcast.popTypeList = [
        {
          "name": "全部",
          "index": 0,
          "isFree": "",
          "itemColor": "#0a9dc7" //默认全部
        },
        {
          "name": "免费",
          "index": 1,
          "isFree": 0,
          "itemColor": "#000000"
        },
        {
          "name": "付费",
          "index": 2,
          "isFree": 1,
          "itemColor": "#000000"
        }];//2017/12/5 修改初始状态
      myLiveBroadcast.popStateList = [
        {
          "name": "全部",
          "index": 0,
          "isLive": "",
          "itemColor": "#0a9dc7" //默认全部
        },
        {
          "name": "直播中",
          "index": 1,
          "isLive": 1,
          "itemColor": "#000000"
        },
        {
          "name": "未开始",
          "index": 2,
          "isLive": 0,
          "itemColor": "#000000"
        }, {
          "name": "已结束",
          "index": 3,
          "isLive": 2,
          "itemColor": "#000000"
        }];//2017/12/5 修改初始状态
      fnPerson_LiveList("", "", "", 0);
      $scope.$broadcast('scroll.refreshComplete');//广播结束
    }

  }
})();
