/**
 * Created by zjw-pc on 2016/5/23.
 */
(function () {
  //'use strict';
  angular.module("myApp")
    .controller("wikipediaController", wikipediaController);

  function wikipediaController($ionicPopup, $scope, $cordovaToast, loadingService, wikipediaService, _customerType) {
    var wikipedia = this;
    wikipedia.fnJournalismList = fnJournalismList;//请求新闻列表方法
    wikipedia.JournalismList = [];//用来接收数据的数组
    wikipedia.loadNewerStories = loadNewerStories;//下拉刷新方法
    wikipedia.imgList = ["img/new_img.png", "img/new_img1.png", "img/new_img2.png", "img/new_img3.png", "img/new_img4.png",
      "img/new_img5.png", "img/new_img6.png", "img/new_img7.png", "img/new_img8.png", "img/new_img9.png", "img/new_img10.png"];
    wikipedia.CurrentPage = 1;
    /**
     * 请求新闻列表
     */
    function fnJournalismList() {
      loadingService.show();
      wikipediaService.FunJournalismList(wikipedia.CurrentPage, 20)
        .then(function (data) {
          for (var i = 0; i < data[0].length; i++) {
            var item = {
              "NewID": data[0][i].NewID,
              "SubjectID": data[0][i].SubjectID,
              "SubjectName": data[0][i].SubjectName,
              "Title": data[0][i].Title,
              "Type": data[0][i].Type,
              "PreviewNum": data[0][i].PreviewNum,
              "ReleaseOwnerName": data[0][i].ReleaseOwnerName,
              "ReleaseTime": data[0][i].ReleaseTime,
              "img": wikipedia.imgList[Math.floor(Math.random() * 10)]
            };
            wikipedia.JournalismList.push(item);
          }
          loadingService.hide();
        }, function (error) {
          $cordovaToast.showShortBottom('网络出现异常！');
        });
    }

    fnJournalismList();

    /**
     * 刷新数据
     */
    function loadNewerStories() {
      wikipedia.CurrentPage = ++wikipedia.CurrentPage;
      if (wikipedia.CurrentPage > 6) {
        wikipedia.CurrentPage = 0;
        $scope.$broadcast('scroll.refreshComplete');//广播结束
        return
      }
      wikipedia.JournalismList = new Array();
      wikipedia.fnJournalismList();
      $scope.$broadcast('scroll.refreshComplete');//广播结束
    }
  }
})()
