/**
 * Created by trueideal on 2016/5/14.
 */
(function () {
  var httpInterceptor = function ($provide, $httpProvider) {
    $provide.factory('httpInterceptor', function ($q,$injector,$cordovaToast) {
      return {
        response: function (response) {
          return response || $q.when(response);
        },
        responseError: function (rejection) {
          if (rejection.status === 401) {
            // you are not autorized
          }
          if (rejection.status === 500) {
            $injector.get('loadingService').hide();
          }
          if (rejection.status === -1) {
            $injector.get('loadingService').hide();
            $cordovaToast.showShortBottom('网络异常！请检查设备是否可以联网！');
          }
          return $q.reject(rejection);
        }
      };
    });
    $httpProvider.interceptors.push('httpInterceptor');
  };
  angular.module("myApp").config(httpInterceptor);
}());
