/**
 * Created by trueideal on 2016/5/14.
 */
(function () {
    angular.module("myApp")
        .factory("loadingService", loadingService);

    function loadingService($ionicLoading) {
        return {
            show: function (content) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="android"></ion-spinner>',
                    animation: 'fade-in',
                    showBackdrop: true,
                    duration: 10000,//10000毫秒
                    showDelay: 0
                });
            },
            hide: function () {
                $ionicLoading.hide();
            }
        }
    }
})()
